* -*- mode:Mail -*-
	STITLE ERABLE Library User Words

*  (c) 07/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the ERABLE package.
*  See copying.doc for licensing information
	
INCLUDE erromid.h
INCLUDE erextdec.h
INCLUDE kextdec.h
INCLUDE keydefs.h
INCLUDE khash.h
INCLUDE global.s

*****************************************************************
* The user module contains the "xNames" - the user words.  These
* will be visible to the user.  The nibble that precedes each
* xName tells the parser that this is a non-algebraic.  Note that
* the user words are specified with the compiler directive
* "xNAME".
*****************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME XY
::
CK2
AXLext NOTLISTcase SETSIZEERR
SWAP AXLext NOTLISTcase SETSIZEERR
CK2FPOLY
DUPLENCOMP 3PICK LENCOMP #= NcaseSIZEERR ZERO BINEVALext XYext
;
*********
ASSEMBLE
         CON(1)  8
RPL
* Renvoie la matrice identit\'e formelle (semblable \`a ID VXN)
xNAME idn
::
CK1&Dispatch
real :: DUP %0> NcaseTYPEERR
	DUPDUP %FLOOR %= NcaseTYPEERR
	idnext
	;
any ::	DTYPENDO? NcaseTYPEERR
	idnext
	;
;
******************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME TRAN
::
CK1
dARRYcase TRANext
DTYPFMAT? NcaseSIZEERR TRANext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME TR
::
CK1 DTYPENDO? NcaseSIZEERR TRext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME MAD
::
CK1
CKFPOLYext LVARext VXXLext MADJext
{ ZERO TWO THREE ONE } FROMLISText
ZEROSWAP RCLVX ONE{}N VAL2ext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME rref
::
CK1
internalflag ClrUserFlag 
AXLext DTYPFMAT? NcaseTYPEERR
STOMAText ONE XREDext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME GCD1
::
CK2&Dispatch
any ::  ZERO BINEVALext GCDext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME LCM1 ( P1, P2 -> PPMC[P1,P2] )
* Remarque, PPMC est obtenu par la formule PPMC*PGCD=P1*P2
::
CK2&Dispatch
any ::  BIN2EVALext :: 2DUP GCDext RDIVext ; x*ext  ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME SIMP2
::
CK2 CK2FPOLY SETQext BIN2EVALext SIMPext
;
*********
ASSEMBLE
         CON(1) 8
RPL
xNAME DIVIS
::
CK1
QOBJext :: CKFPOLYext ONE MONOEVALext DIVISext ;
;
************
ASSEMBLE
         CON(3)  000
RPL
xNAME LGCD
::
CK1&Dispatch
list :: internalflag ClrUserFlag 
	ONE TOLISText LPGCDext { ONE ZERO } FROMLISText 
	;
;
***********

ASSEMBLE
         CON(1)  8
RPL
xNAME GCD3
::
CK2
internalflag ClrUserFlag
TWO TOLISText
EGCD?ext
ZEROZEROZERO THREE{}N FROMLISText
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME FCOEF
::
CK1 
NOTLISTcase SETSIZEERR
CKFPOLYext
INNERCOMP TWO #/ SWAP #1=case SETSIZEERR
%1 DUPROT
ZERO_DO (DO)
	( rac1, num1, ..., rack, numk, num, deno )
	2SWAP dREALNcase SETSIZEERR
	( rac1, num1, ..., num, deno, rack, numk )
	RCLVX ROT x-ext
	OVER %ABS
	( .., num, deno, mult, factk, | mult | )
	x^ext
	SWAP %0<
	( ..., num, deno, factk, mult<0? )
	ITE 	x*ext
		:: ROTSWAP x*ext SWAP ;
	LOOP
NDXFext
;
*****************************
ASSEMBLE
         CON(3)  000
RPL
xNAME SQRT
::
CK1&Dispatch
any :: CKFPOLYext ZERO MONOEVALext XSQRext ;
;
****************
ASSEMBLE
         CON(3)  000
RPL
xNAME COLC
::
CK1&Dispatch
any :: CKFPOLYext QOBJext COLCext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME EXPA
::
CK1&Dispatch
any :: CKFPOLYext SETQext
       QOBJext 
       ::	idntlamcase 
		::	DUPSAFE@ case SWAPDROP
			;
		DUPTYPESYMB? NOT?SEMI 
		DUPDUP LENCOMP NTHCOMPDROP EQ: x= 
		NOTcase	SIMP1ext
		' xOBJ> EvalNoCK 2DROP 
		( membre droit, membre gauche )
		SIMP1ext OVER x= ( ca evite une pile degueulasse si ? )
		( droit, gauch=droit )
		SWAP LVARext 
		( gauche=droit, droit, lvar )
		DUPNULL{}? case2DROP
		SWAPDROP CARCOMP ISOLext ' x= EvalNoCK
		;
	;
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME FACTO
::
CK1 CKFPOLYext
internalflag ClrUserFlag
FACTOext ROTDUP 2SWAP
{ ZERO ONE } FROMLISText
( lvar, poly, facteurs )
;
*************
ASSEMBLE
         CON(1)  8
RPL
xNAME FROOTS
::
CK1
dREALNcase ::	CKFPOLYext 
		internalflag ClrUserFlag 
		FACT1ext
		( lvar, poly-l, root-l )
		SWAP3PICK VALext
		( lvar, root-l, poly )
		ONE ROT
		( lvar, poly, #1, root-l )
		4PICK CDRCOMP VALOBJext internalflag ClrUserFlag
		( lvar, poly, roots )
		;
%ABSCOERCE CK3NOLASTWD
CK&DISPATCH1
# 510 SOLVext			
;
**************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME AXL
::
CK1&Dispatch
list :: DTYPFMAT?
        ITE LXAext
            xOBJ\->
        x\->ARRY
        ;
arry AXLext
any NOP
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME ?
::
CK0 ?ext
;
**************************
ASSEMBLE
         CON(3)  000
RPL
xNAME abs
::
CK1&Dispatch
any ::	CKFPOLYext SINCOSext DMONOEVALext :: DUP RCONJext RMULText XSQRext ;
	;
;
********
ASSEMBLE
         CON(3)  000
RPL
xNAME XNUM
::
CK0
TWO SetSysFlag
* THREE SetSysFlag
real_intflag ClrUserFlag 
pgcdflag ClrUserFlag
DEPTH #0=?SEMI
CKFPOLYext QOBJext SIMP1ext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME XQ
::
CK0
TWO ClrSysFlag
* THREE ClrSysFlag
SETQext
DEPTH #0=?SEMI
RCLEPS
%LOG %ABSCOERCE DOFIX QOBJext x\->Q DOSTD
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME arg
::
CK1&Dispatch
any :: CKFPOLYext SINCOSext SIN2TCext 
       DMONOEVALext :: DUP RIMext SWAP RREext ARGext ; 
       ;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LVAR
::
CK1 LVARext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME MMULT
::
CK3
dREALNcase SETSIZEERR
( multiplication avec des matrices et vecteurs )
* %0 matrice*matrice
* %1 matrice*vecteur colonne
* %2 matrice*scalaire, %6 scalaire*matrice
* %3 vecteur*scalaire, %7 scalaire*vecteur
%ABSCOERCE
FOUR #/
( o1, o2, reste, quot )
#0=ITE UNROTSWAP UNROT
( reste, o2, o1 )
( teste o1 )
DUPTYPEARRY? ?SKIP ::	NOTLISTcase SETSIZEERR 3PICK #3=
			ITE	CKFPOLYext 
				:: DTYPFMAT? NcaseSIZEERR ;
			;
( teste o2 )
SWAP3PICK #>1
ITE	CKFPOLYext 
	::	DUPTYPEARRY? ?SEMI
		NOTLISTcase SETSIZEERR 
		3PICK 
		#0=ITE :: DTYPFMAT? NcaseSIZEERR ;
			CKFPOLYext
		;
( reste, o1, o2 )
ROT 
( reste, o1, o2 )
DUP#0=csedrp :: TWO BINEVALext MMULText ;
DUP#1= casedrop :: ONE BINEVALext MVMULText ;
#2= case :: TWO BINEVALext MPMULText ;
ONE BINEVALext VPMULText
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME EPSX0
::
CK1&Dispatch
any ::  ELMGext TRIMext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME re
::
CK1&Dispatch
any :: CKFPOLYext SINCOSext DMONOEVALext RREext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME im
::
CK1&Dispatch
any :: CKFPOLYext SINCOSext DMONOEVALext RIMext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME conj
::
CK1&Dispatch
any :: CKFPOLYext SINCOSext DMONOEVALext RCONJext ;
;
***********
ASSEMBLE
         CON(1)  8
RPL
xNAME  FXND
::
CK1
DUPTYPESYMB? NOTcase %1
DUPDUP LENCOMP NTHCOMPDROP EQ: x= NOTcase FXNDext
' xOBJ> EvalNoCK 2DROP
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME NDXF
::
CK2&Dispatch
any ::  CK2FPOLY NDXFext ;
;
*********
ASSEMBLE
         CON(3) 000
RPL
xNAME PF
::
CK1&Dispatch
symb 
::
VXLVARext SIX PFext
( lvar, quotient, num1, f1, m1, ..., numk, fk, mk, #3k )
::	DUP#0=csDROP
	HXS 1 0 SWAP THREE #/ SWAPDROP
	ZERO_DO (DO)
		( lvar, quotient, num1, f1, m1, ..., numk, fk, mk, res )
		4UNROLL HXS 1 0 SWAP %ABSCOERCE
		( lvar, quotient, num1, f1, m1, ..., res, numk, fk, res_inter, #mk )
		ZERO_DO	(DO)
			( numk, fk, res_inter )
			ROT 3PICK DIVext
			( fk, res_inter, quot, reste )
			SWAP 4UNROLL
			( newnum=quot, fk, res_inter, reste )
			3PICK ISTOP-INDEX UNCOERCE x^ext NDXFext SWAP x+ext
			LOOP
		UNROT2DROP x+ext
		LOOP
	( lvar, quot, res )
	x+ext
	;
ZEROSWAP ROT VAL2ext
internalflag ClrUserFlag
;
;
***********
ASSEMBLE
         CON(3)  000
RPL
xNAME EXEC
::
CK2&Dispatch
2LIST :: CK3NOLASTWD MEVALext ;
symb :: DUPDUP LENCOMP NTHCOMPDROP EQ: x=
        NOTcase :: ISOLext ' x= EvalNoCK ;
        xOBJ\-> 2DROP 
	( obj, o1, o2 )
	( si o1 est une fnct, on recherche les derivees dans obj )
	( sinon on isole si possible 1 idnt a gauche et on cree 2 listes )
	OVER DUPTYPESYMB? NOTcasedrop MEVALext
	( obj, o1, o2, o1 )
	DUPDUP LENCOMP NTHCOMPDROP
	( obj, o1, o2, o1, operateur )
	EQ: xFCNAPPLY
	( obj, o1, o2, o1, ?fnct utilisateur )
	ITE ::	' xOBJ\-> EvalNoCK
		( obj, o1, o2, arg1, ..., argk, %arg, idnt )
		SWAP COERCE DUPUNROT #2+UNROLL {}N
		( obj, o1, o2, idnt, { arg1 ... argk } )
		5PICK LIDNText
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj } )
		( teste si obj2 est une fonction utilisateur )
		4PICK LVARext SWAPDROP CARCOMP DUPTYPESYMB?
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj }, var2, ? symb )
		ITE :: DUPDUP LENCOMP NTHCOMPDROP EQ: xFCNAPPLY ;
		    FALSE
		( obj, o1, o2, idnt, { arg1 ... argk }, { idnt de obj }, var2, flag )
		ITE 	::	( cherche la liste des arg de fnct2 )
				' xOBJ\-> EvalNoCK SWAP COERCE 
				DUPUNROT #2+UNROLL {}N
				;
			:: DROP 3PICK 3PICK ;
		( obj, o1, o2, idnt, { args }, { idnt de obj }, newidnt, { newargs } )
		NULL{} DUP 5ROLL
		[BEGIN]
			DUPNULL{}?
		NOT_WHILE
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		( pour chaque idnt de obj, on teste si "idnt" de obj )
		( contient "idnt" )
		::
		DUP CDRCOMP SWAP CARCOMP
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		DUP 
		ID>DERext
		( ..., o1, o2, idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, stripped_idnt )
		TEN PICK EQUAL NOTcase2DROP
		( ..., o1, o2, idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste )
		DUPNULL{}? case2DROP
		( creation de newidnt[newargs] )
*		6PICK INNERDUP #8+ PICK ONE SYMBN SWAP xFCNAPPLY
		TEN PICK
*		fin de modification
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, o2 )
		SWAPDUP LENCOMP
		ZERO_DO 
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
			DUP CDRCOMP SWAP CARCOMP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee )
			8PICK OVER NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste, no de derivee, newarg_no )
			4ROLLSWAP 3PICK 
			:: 
			SWAP DUPTYPESYMB? 
			IT :: ' TYPEIDNT? Find1stTrue NOTcase %1 ;
			idntlamcase :: SWAPDROP DERIVext ;
			( symb, #, obj )
			DROP UNCOERCE DO>STR SWAPINCOMP get1 5ROLL 
			CARCOMP ID>$ &$ CHR_d >H$ $>ID ONE SYMBN 4UNROLL SYMBN
			;
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, no de derivee, resultat )
			TEN PICK ROT NTHELCOMP NcaseTYPEERR
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat, arg_no )
			DUPTYPESYMB? 
			ITE ::	DUP ' TYPEIDNT? Find1stTrue 
				NOTcaseDROP DERIVext RDIVext
				;
				DROP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, liste, resultat )
			SWAPLOOP
			( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt, resultat, liste )
		DROP 4ROLLSWAP >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt }, objidnt )
		4ROLL 7PICK INNERDUP #3+ ROLL ONE SYMBN SWAP xFCNAPPLY >TCOMP UNROT
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		;
		( ..., idnt, { args }, newidnt, { newargs }, l1, l2, { objidnt } )
		[REPEAT]
		DROP 6UNROLL 6UNROLL 4DROP
		( obj, o1, o2, l1, l2 )
		; 
	    ::	( obj, o1, o2, o1 )
		4PICK DUP' x\.S_ALGEBRAIC EQUALPOSCOMP
		( obj, o1, o2, o1, obj, # )
		DUP#0<>
		IT ::	 #1- NTHCOMPDROP CARCOMP
			( obj, o1, o2, o1, idnt )
			2DUP EQUALPOSCOMP
			;
		( obj, o1, o2, o1, [ idnt, # | obj, #0 ] )
		#0=ITE	:: DROP ' TYPEIDNT? Find1stTrue ;
			:: SWAPDROP TRUE ;
		( obj, o1, o2, [ indt, TRUE | FALSE ] )
		NOTcase :: RDROP MEVALext ;
		( obj, o1, o2, idnt )
		UNROT 2DUP ' x- EvalNoCK 
		( obj, idnt, o1, o2, o1-o2 )
		4ROLL
		( obj, o1, o2, o1-o2, idnt )
		ISOLext
		( obj, o1, o2, idnt, valeur )
		ONE{}N SWAP ONE{}N SWAP
		( obj, o1, o2, l1, l2 )
		;
	( obj, o1, o2, l1, l2 )
	ROT >HCOMP UNROTSWAP
	( obj, l2, l1, o1 )
	>HCOMP SWAP MEVALext
        ;
seco :: ' QOBJext SWAP 2Ob>Seco EVAL ;
idnt :: ISOLext ' x= EvalNoCK ;
;
***************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME PFEXEC
::
CK2 SETQext
PFEXECext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME EXPLIN
::
CK1&Dispatch
any SIGMAEXPext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME PTAYL
::
CK2&Dispatch
any :: CK2FPOLY ZERO BINEVALext PTAYLext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME DIV1
::
CK2&Dispatch
any :: CK2FPOLY ZERO BINEVALext RDIVext ;
;
**********
ASSEMBLE
         CON(1)  8
RPL
xNAME HORN
::
CK2 
CK2FPOLY
internalflag ClrUserFlag
TWO TOLISText
HORNext
ZEROZEROZERO THREE{}N FROMLISText
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LU2
::
CK1
DTYPENDO? NcaseSIZEERR
( endomorphisme )
TRANext DUP xidn x+ TRANext
( { A idn } )
ONE REDLIBext DUP' NULLLAM SIX NDUPN DOBIND 
' 5PICK 3GETLAM EVAL 
ABND
( { l u } )
TRANext
INNERCOMP #2/
( l1, ...ln, u1, ..., un, #n )
DUPDUP #2+UNROLL
( l1, ..., ln, #n , u1, ..., un, #n )
{}N TRANext OVER#2+UNROL {}N
( u, l )
TRANext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME der
::
CK2&Dispatch
any ::	CK2FPOLY internalflag SetUserFlag
	DERIVext
	internalflag ClrUserFlag
	;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME  RISCH
::
CK1&Dispatch
any ::	RCLVX RISCHext ;
;
*************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME add
::
CK2&Dispatch
any :: asopext RADDext
       ;
;
*********
ASSEMBLE
         CON(3)	000
RPL
xNAME SUBT
::
CK2&Dispatch
any :: asopext RSUBext
       ;
;
******************
ASSEMBLE
         CON(3)	000
RPL
xNAME MULT
::
CK2&Dispatch
SIXTYEIGHT x*
TWENTY x*
THIRTYSIX x*
* ARRYREAL x*
* FOURTWO x*
FOUR :: AXLext xMULT ;
any ::	::	CK&DISPATCH1
		2LIST TWO ( matr/vect * matr/vect )
		SIXTYFOUR ONE
		list THREE
		EIGHTY ONE
		any ZERO
		;
	( o1, o2, # )
	DUP#0=csedrp :: ZERO BINEVALext RMULText ;
	DUP#1= casedrop :: SWAP xMULT ;
	#2- #6* OVER DEPTHext #1= IT #1+
	UNCOERCE xMMULT
	;
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME DIV2
::
CK2 CK2FPOLY 
BIN2EVALext DIVext
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME POWER
::
CK2&Dispatch
# 80 RPext
SYMREAL :: x^ext SIMP1ext
           ;
ARRYREAL :: 'x* MPext ;
any :: RESOROMP xMULT MPext ;
;
*********
ASSEMBLE
         CON(3)  000
RPL
xNAME CHS
::
CK1&Dispatch
any :: CKFPOLYext DMONOEVALext RNEGext ;
;
**********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME VER
::
"http://www-fourier.ujf"
DISPROW1
"-grenoble.fr/~parisse"
DISPROW2
SetDA1Temp
CONTEXT@ HOMEDIR
% .0000000001 ' ID EPS STO
'IDX ' ID VX STO
'IDX @ IT :: DROP 'IDX PURGE ;
%2 ' ID MODULO STO
CONTEXT!
SEVENTEEN ELEVEN DO INDEX@ SetUserFlag LOOP
THIRTEEN ClrUserFlag
THIRTY SEVENTEEN DO INDEX@ ClrUserFlag LOOP
TWENTYONE SetUserFlag
TWENTYSEVEN SetSysFlag
TWO ClrSysFlag
VERNUMext
;
*********
ASSEMBLE
         CON(1)  8
RPL
xNAME LIDNT
::
CK1 LIDNText
;
***********************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LCXM
::
( L,C, prg -> matrice )
CK3&Dispatch
# 118	LCXMext
;
*******************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME cross
::
CK2
AXLext SWAP AXLext
CK&DISPATCH1
2LIST :: DUPLENCOMP #3= 3PICK LENCOMP #3= AND NcaseSIZEERR
         INCOMPDROP 4ROLL INCOMPDROP
         ( a,b,c,d,e,f )
         2DUP 7PICK RMULText SWAP 6PICK RMULText RSUBext
         ( a,b,c,d,e,f fb-ec )
         7UNROLL 4ROLL 4PICK RMULText SWAP 6PICK RMULText RSUBext
         ( bf-ce,a,b,d,e cd-fa )
         5UNROLL 4ROLL RMULText UNROT RMULText RSUBext
         ( bf-ce, cd-fa, ae-bd )
         THREE{}N
         ;
;
******************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TRIGSIN
::
CK1&Dispatch
any ::	CKFPOLYext sincosflag SetUserFlag
	QOBJext TRIGext
	;
;
********************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME PCAR
::
CK1
AXLext DTYPENDO? NcaseSIZEERR
DUPLENCOMP idnext
' ID  MPMULText MSUBext
DEText
;
****************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME det
::
CK1&Dispatch
list DEText
arry xDET
;
*****************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME LIMIT
::
CK2&Dispatch
symb :: ' xOBJ> EvalNoCK EQ: x= NcaseTYPEERR
	DROP LIMIText
	;
;
***************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME der1
::
CK1&Dispatch
any :: RCLVX xder ;
;
******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME RANG
::
CK1
AXLext DTYPFMAT? NcaseTYPEERR
STOMAText ' 5PICK XREDext
;
******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME RDET
::
CK1
DTYPENDO? NcaseTYPEERR
STOMAText RDEText
;
*******************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME INVL
::
CK1&Dispatch
list ::	DTYPENDO? NcaseTYPEERR
	STOMAText INVLext SWAPDROP
	;
any	:: %1 SWAP xDIV1 ;
;
*******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME SYST
::
CK1&Dispatch
list :: STOSYSText SYSText SWAP ROTDROP ROTDROP
	;
;
*******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME SOLGEN
::
CK1&Dispatch
list :: STOSYSText SOLGENext ROTDROP ROTDROP
	;
;
*******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME JORDAN
::
( endomorphisme  ou 
  poly-madj, poly carac -> )
CK1
complexflag SetUserFlag
* DTYPEARRY? ITE TRUE 
DTYPENDO?
IT ::	DUP' ID MATRIX STO
	xMAD
	;
CK2NOLASTWD FACT1ext 
( poly-madj-ext, lvar, poly carac, lfac )
4UNROLL FXNDext DIVOBJext 4UNROLL
( poly car, lfac, poly-madj-ext, lvar )
CDRCOMP VXXLext 2SWAP
( lvar, poly-madj, poly car, lfac )
CK&DISPATCH1
#5555
:: ZERO REDLIBext
   ( rappelle LAM8: PIVOT, LAM7: EXL et LAM6: ELEM )
   ( stk= lvar, poly matr, poly car, roots, PIVOT, EXL, ELEM, prg )
   ZERO ( LAM5 ) 
   ZEROZERO 2DUP
   ( initialisation des 8 variables locales )
   ' NULLLAM EIGHT NDUPN DOBIND
   { BlankDA12 EIGHTEEN DISPROW1 DUP EDITDECOMP$
     :: TWO FIVE ; Disp5x7
     NINETEEN DISPROW6
     } User1IT
   displayflag TestUserFlag 4UNROLL displayflag ClrUserFlag
   ( stack = lvar, flag1, polynome matriciel, polynome carac., liste racines )
   SWAPDUP 4UNROLL
   ( lvar, flag1, pcar ,polynome matriciel, liste racines, pcar )
   4UNROLLDUP
   ( lvar, flag1, pcar, pcar, polynome matriciel, liste rac, liste rac )
   5UNROLL NULL{} 3UNROLL
   ( lvar, flag1, liste rac, pcar, pmin, null{}, polynome matriciel, liste rac )
   BEGIN
        DUPLENCOMP #0<>
   WHILE
	( ..., pmin, null{}, polynome matriciel, liste rac )
        INNERCOMP #2- {}N
	( ..., pmin, null{}, polynome matriciel, rac, mul, liste rac )
	4UNROLL COERCE 1PUTLAM
        ( , pmin, {vectp}, liste autres rac, poly mat, racine )
        8PICK 
	IT :: DUP DO>STR APPEND_SPACE 1GETLAM DO>STR &$ DISPROW7 ;
	1GETLAM
        ( , pmin, {vectp}, autres rac, poly mat, racine, multiplicite )
        #1=case
        :: ( , pmin, {vectp}, autres rac, poly mat, racine )
           2DUP mpmultflag SetUserFlag HORNext mpmultflag ClrUserFlag
	   UNROT2DROP
           ( , pmin, {vectp}, autres rac, poly mat, racine, matrice-col )
           TRANext AXLext INNERCOMP
           [BEGIN]
                  #1-SWAP DUP TRIMext { HXS 1 0 } EQUAL
                  ( recherche 1 ligne non nulle )
           [WHILE]
                  DROP
           [REPEAT]
           LPGCDext HXS 2 10 SWAP NDXFext VPMULText
           OVER#2+UNROL NDROP
           ( lvar, flag1, liste rac, pcar , pmin, {vectp}, autres rac, poly mat, racine, vectp )
           SWAP ZEROSWAP ELEVEN PICK VALOBJext DO>STR >TAG 4ROLL SWAP >TCOMP UNROTSWAP
           ( , pmin, {vectp}, poly mat, autres rac )
           ;
        ( pile = det[A], A^-1, flag1, valp, pcar, pmin, {vectp}, autres rac, poly mat, r )
        ( LAM4= taille de la pile des P[] )
        ( LAM3= nombre de vecteurs caract\'eristiques trouv\'es )
        ( LAM2= nombre de vecteurs propres trouv\'es )
        ( LAM1= dimension de l'espace caract\'eristique )
        2DUP 1GETLAM
        ZERO_DO (DO)
                mpmultflag SetUserFlag HORNext mpmultflag ClrUserFlag
		TRANext AXLext UNROT
                LOOP
        ( P[r], ..., P|k-1|[r], P|k|, r )
        2DROP 1GETLAM ROLL
        1GETLAM 4PUTLAM ( taille de la pile des P )
        ZEROZERO 2PUTLAM 3PUTLAM NULL{} 1GETLAM #1+UNROLL
        ( nombre de vecteurs propres, de vecteurs caract. )
        ONEONE
        ( pile = null{}, P'[r], ..., P|k-1|[r], P[r], #1, #1 )
        ( algorithme de recherche des cycles de Jordan )
        ( null{}, matrices de la pile, matrice, l, c -> {vectcarac} )
        BEGIN
             ( vectc, matrices de la pile, matrice, l, c )
             3GETLAM 1GETLAM #<
        WHILE
             8GETLAM EVAL
             ( PIVOT )
             ( #0= pas de pivot trouv\'e, #1= ELEM, #2= EXL )
**** BUG dans pivot, si il est dans la dernier colonne, il peut manquer
**** des inversions
             DUP#0=csedrp
             :: ( rechercher les cycles )
                ( ajuster 2,3,4PUTLAM )
                ( recr\'eer la matrice du niveau 1 de la pile )
                ( stack=vectc, pile, matrice )
                ( \'elimine les lignes nulles de la matrice )
                DUPINCOMP
                BEGIN
                     SWAP ELMGext DUP TRIMext { HXS 1 0 } EQUAL
                     ROTDUP 2GETLAM #> ROTAND
                WHILE
                     SWAP DROP#1-
                REPEAT
                DUPDUP #2+UNROLL {}N SWAP
                ( vectc, pile, vecteurs propres, #vect )
                DUP#0=IT ::	( matrice nulle -> diviser le polynome minimal )
				4GETLAM #8+ ROLL 4GETLAM #5+ PICK
				HORNext 
				2DROP 4GETLAM #8+ UNROLL
				;
                2GETLAM
                2DUP#>
                ITE :: 	( vectc, pile, vecteurs propres, #vectp, #old_vectp )
			OVERSWAP #- 4GETLAM #* 3GETLAM #+ 3PUTLAM
			( vectc, pile, vecteurs propres, #vect )
			2PUTLAM
			4GETLAM #2+ROLL 2GETLAM
			#1+_ONE_DO (DO)
				( \'ecrire cycles de Jordan trouv\'es )
				4GETLAM
				( pile, vect propres, vectc, #vect )
				DUP#1= ITE_DROP
				:: ONE_DO (DO)
					( pile, vect propres, vectc )
					INDEX@ #3+PICK
					JINDEX@ NTHCOMPDROP
*					5GETLAM EVAL ( simplification )
					", Char: " >TAG apndvarlst
				   LOOP
				   ;
				( pile, vect propres, vectc )
				OVER INDEX@ NTHCOMPDROP ", Eigen:" >TAG apndvarlst
				( pile, vecteurs propres, vectc )
			LOOP
			4GETLAM #2+UNROLL
			( vectc, pile, vecteurs propres )
			;
                     2DROP
                ( vectc, pile, [vecteurs propres] )
                ( recr\'eer la pile de matrices en d\'ecalant )
                SWAPDROP 4GETLAM #1- DUPDUP 4PUTLAM 
		( vectc, P'[r], ..., P|k-1|[r], vectp, #k-1, #k-1 )
		DUP#0=case ROTDROP
		ZERO_DO (DO)
			get1
			( vectc, P|2|[r], ..., P|k-1|[r], vectp, #k-1, P'[r] )
			DUPONE 2GETLAM SUBCOMP 4UNROLL
			( vectc, P|2|[r], ..., P|k-1|[r], antecedents, vectp, #k-1, P'[r] )
			DUPLENCOMP 2GETLAM #1+SWAP SUBCOMP ROTSWAP &COMP
			( vectc, P|2|[r], ..., P|k-1|[r], antecedents, #k-1, P'[r] )
			UNROT
			LOOP
		( vectc, P'[r], ..., P|k-1|[r], antecedents, #k-1 )
		get1 UNROT2DROP
                ( vectc, P|2|[r],..., P|k-1|[r], P'[r] )
		ONEONE
                ;
             #2= IT :: ( changes de lignes sur 4GETLAM matrices )
                       ( vectc, pile, mat, l, c, l1, l2 )
                       4GETLAM DUP #5+ SWAP
                       ZERO_DO (DO)
                               ( vectc, pile, l, c, l1, l2, # )
                               6ROLL 2OVER NULL{} 7GETLAM EVAL
                               DROPOVER UNROLL
                               LOOP
                       3DROP
                       ;
             ( manipulations lmentaires de lignes )
             ( vectc, pile, l, c )
             3PICK 3PICK NTHCOMPDROP OVER NTHCOMPDROP RNEGext
             ( vectc, pile, l, c, pivot )
             4PICK LENCOMP #1+ 4PICK #1+
		2DUP#> ITE
		::
                   DO
                   DUP 5PICK INDEX@ NTHCOMPDROP 4PICK NTHCOMPDROP
                   ( vectc, pile, l, c, pivot, pivot, element )
                   INDEX@ SWAP 6PICK FOUR {}N
                   ( vectc, pile, l, c, pivot, ELEM )
                   4GETLAM DUP #5+ SWAP
                   ZERO_DO (DO)
                           ( vectc, pile, l, c, pivot, ELEM , # )
                           6ROLL 3PICK ' DROP NULL{} 6GETLAM EVAL
                           DROPOVER UNROLL
                           LOOP
                   2DROP
                   ( vectc, pile, l, c, pivot )
                   LOOP
		;
		2DROP
             DROP #1+SWAP #1+SWAP
             ( vectc, pile, l, c )
        REPEAT
        ( fin de la recherche des cycles de Jordan )
        2DROP 4GETLAM NDROP
        ( lvar, flag1, liste rac, pcar, pmin, {vectp}, autres rac, poly mat, racine, {vectc} )
        SWAP ZEROSWAP ELEVEN PICK VALOBJext DO>STR
        ( ..., { vectc }, tag )
        SWAPINCOMP get1 SWAPDUP
        ( ..., vectc1,..., vectck, tag, #k, #k )
        ZERO_DO (DO)
                ( vectc1,..., vectck, tag, #k )
                get1 ' xOBJ> EvalNoCK 4PICK SWAP&$ >TAG UNROT
                LOOP
        SWAPDROP {}N
        ( , pmin, {vectp}, autres rac, poly mat, {vectc} )
        4ROLLSWAP &COMP UNROTSWAP
        ( , pmin, {vectp}, poly mat, autres rac )
   REPEAT
   ( [det[A], A^-1], lvar, flag1, valp, pcar, pmin, {vectp}, poly mat, null{} )
   DROP 5UNROLL 4ROLL
   ( [det[A], A^-1], lvar, flag1, poly mat, pcar, pmin, {vectp}, valp )
   ABND
   displayflag 7ROLL ITE SetUserFlag DROP
   ( [det[A], A^-1], lvar, poly mat, pcar, pmin, {vectp}, valp )
   5ROLLDROP
   { ONE ONE TWO ONE }
   FROMLISText 
   ( [det[A], A^-1], pcar, pmin, {vectp}, valp )
   ( retransforme en symbolique le poly car et le poly min )
   2SWAP TWO{}N ONESWAP RCLVX ONE{}N VALOBJext INCOMPDROP 4ROLL
   ( [det[A], A^-1], poly mat, valp, pcar, pmin, {vectp} )
   ;
;
********************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TRIG
::
CK1&Dispatch
any ::	CKFPOLYext QOBJext :: SINCOSext TAN2SC2ext TRIGext ;
	;
;
********************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TRIGLIN
::
CK1&Dispatch
any ::	CKFPOLYext QOBJext
	::	LINEXPA
		INNERCOMP %0 SWAP #2/
		ZERO_DO (DO)
			UNROT SIMP1ext SWAP x*ext x+ext
			LOOP
			;
	;
;
********************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME LDEC
::
CK2 CK2FPOLY
( 2nd membre, eq. caracteristique | 2nd membre, matrice -> solution )
SWAP xLAP SWAP AXLext
NOTLISTcase :: %1 UNROT DUPUNROT NDXFext xILAP ;
DTYPENDO? NcaseTYPEERR
DUPLENCOMP 3PICK LENCOMP #= NcaseTYPEERR
( lap[2nd membre], matrice )
( mettre x en tete de liste des variables )
TWO{}N DUP
::	LISTOPext
	LVARDext RCLVX
	( symb, lvar, vx )
	2DUP EQUALPOSCOMP
	( symb, lvar, vx, # pos )
	DUP#0= casedrop >HCOMP
	ROTDUP CARCOMP
	( symb, vx, #pos, lvar, 1st of lvar )
	UNROT PUTLIST
	( symb, vx, lvar sans 1er lment )
	ONESWAP PUTLIST
	;
SWAPDROP
VXXLext INCOMPDROP
( lvar, lapl[2nd membre], matrice )
MADJext 2SWAP 2DROP
( lvar, v, M[A,p], pcar )
SWAPINCOMP DUPDUP
( lvar, v, pcar, A1, ..., An, #n, #l )
' NULLLAM DUPTWO DOBIND
( lam1= nbre de lignes des matrices, lam2= nombre de matrices )
ZERO_DO (DO)
	INDEX@ 2PUTLAM
	1GETLAM ZERO_DO (DO)
		1GETLAM ZERO_DO (DO)
			( lvar, v, pcar, An, ..., A1, l1, ..., lj, a1, ..., ak )
			1GETLAM JINDEX@ #+ 2GETLAM #+PICK 2GETLAM #1+ NTHCOMPDROP
			JINDEX@ #1+ NTHCOMPDROP
			LOOP
		1GETLAM {}N TRIMOBJext
		LOOP
	1GETLAM {}N
	LOOP
1GETLAM {}N
1GETABND DUPUNROT #2+UNROLL NDROP
( v, pcar, [p-A]^-1 )
DUP 4ROLL MVMULText
( pcar, [p-A]^-1, [p-A]^-1*v )
ROTSWAP
( [p-A]^-1*pcar, pcar, [p-A]^-1*v )
TWO ZERO ONE THREE{}N FROMLISText SWAP xCOLC
DUPUNROT ' :: x/ symcomp xILAP ; LOPAext
;
*************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME PREVAL
::
( primitive, borne inf, borne sup -> algbrique )
CK3&Dispatch
# A00 PREVALext
;
****************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME ORND
::
CK2
xABS DTYPEREAL? ?SKIP :: DROP %1 ;
RCLEPS
' :: CK&DISPATCH1
     real :: 3GETLAM 2DUP %* %0 URND SWAP %/ 2DUP %- %ABS
             2GETLAM %< IT SWAP DROP
             ;
     TWO :: C%>% 1GETLAM EVAL SWAP 1GETLAM EVAL SWAP
            DUP%0= ITE_DROP %>C%
            ;
     symb :: LISTSECOext ELMGext
             ;
     list LISTSECOext
     arry :: xARRY\-> DUPINCOMP #2= IT %*
             COERCEDUP
             ZERO_DO (DO)
                     ( a1,..., an, size, #n )
                     ROT 1GETLAM EVAL OVER#2+UNROL
                     LOOP
             DROP XEQ>ARRAY
             ;
     ZERO NOP
     ;
' NULLLAM DUPDUP THREE DOBIND
1GETLAM EVAL ABND
;
***********************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME EULER
::
CK1&Dispatch
real ::	NULL{} VXXLext
	DUPTYPEHSTR? NcaseTYPEERR
	SQFFext INNERCOMP HXS 2 10 SWAP #2/
	ZERO_DO (DO)
		( a1,m1, ...,ap,mp, euler )
		UNROT COERCE OVERSWAP #1- RPext
		( ..., euler, ap, ap^[mp-1] )
		DUPUNROT RMULText SWAP RSUBext RMULText
		LOOP
	ZEROSWAP ROT VAL2ext
	;
;
*************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME fact
::
CK1&Dispatch
real ::	   DUP %0> NOTcase %FACT
	   DUP %FP %0= NOTcase %FACT
	   COERCE HXS 2 10 SWAP
	   #1+_ONE_DO (DO)
		      INDEX@ #>HXS RMULText
		      LOOP
	   ZEROSWAP NULL{} VAL2ext
	   ;
any	   x!
;
***************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME comb
::
CK2&Dispatch
2REAL ::	SWAP %ABSCOERCE SWAP %ABSCOERCE
		2DUP#< case2drop %0
		( N P )
		DUP#0= case2drop %1
		2DUP#= case2drop %1
		internalflag SetUserFlag
		2DUP #- UNROT
		#1+SWAP #1+SWAP HXS 2 10 UNROT
		DO
			INDEX@ #>HXS RMULText
		LOOP
		HXS 2 10 ROT
		#1+_ONE_DO (DO)
			INDEX@ #>HXS RMULText
		LOOP
		RDIVext ZEROSWAP NULL{} VAL2ext
		;
;
*******************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME ABCUV
::
CK3 UNROT
( c, a, b )
THREE TOLISText
( lvar, c, a, b )
EGCD?ext
( lvar, c, d, u, v )
2SWAP DIVext
( lvar, u, v, c div d, c mod d )
num0case :: DROP ROTOVER RMULText UNROT RMULText { ZERO ZERO } FROMLISText ;
SETSIZEERR
;
***********************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TAN2SC
::
CK1&Dispatch
any ::	CKFPOLYext QOBJext TAN2SCext ;
;
************************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME LEGENDRE
::
( % -> polynome de Legendre )
CK1&Dispatch
real ::	   %ABSCOERCE
	   DUP#0=csedrp %1
	   DUP#1= casedrop RCLVX
	   HXS 2 10 { HXS 2 20 HXS 1 0 } 
	   3PICK
	   ONE_DO (DO)
		  ( #n, T_k-1 T_k )
		  INDEX@ ZUNCOERCE
		  2DUP HXS 2 40 RMULText HXS 2 20 RADDext RMULText  HXS 1 0 >TCOMP
		  ( T_k-1 T_k k P )
		  4ROLL 3PICK
		  HXS 2 40 RMULText RMULText RSUBext SWAP HXS 2 10 RADDext RDIVext
		  LOOP
	  SWAPDROP
	  ( #n, TN )
	  HXS 2 20 ROT UNCOERCE RPext RDIVext
	  ZEROSWAP RCLVX ONE{}N VAL2ext
	  ;
;
***************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TCHEB
::
( % -> liste des polynomes de Tchebycheff de 0 a % T_n[x]=cos[n*arcos[x]] )
( -% -> U_n[x]=sin[n*arccos[x]]/sin[arccos[x]] )
CK1&Dispatch
real ::	TCHEBext ZEROSWAP RCLVX ONE{}N VAL2ext ;
;
*****************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME HERMITE
::
CK1&Dispatch
real ::	 %ABSCOERCE
	 DUP#0=csedrp %1
	 ::	HXS 2 10 { HXS 2 20 HXS 1 0 }
		ROT DUP#1= caseDROP
		ONE_DO	(DO)
			( H_n-1, H_n )
			DUP HXS 2 20 RMULText HXS 1 0 >TCOMP
			( H_n-1, H_n, 2xH_n )
			ROT INDEX@ #2* ZUNCOERCE RMULText RSUBext
			( H_n, H_n+1 )
			LOOP
		;
	SWAPDROP ZEROSWAP RCLVX ONE{}N VAL2ext
	;
;
*******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME VAND
::
CK1
NOTLISTcase SETSIZEERR
CKFPOLYext DUP1LAMBIND LENCOMP UNCOERCE
DUP' :: 2DROP 4GETLAM INDEX@ #1+ NTHCOMPDROP JINDEX@ UNCOERCE ' x^ EvalNoCK ;
LCXMext
ABND
;
***********************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME HILBERT
::
CK1
CK1Z Z2Rext DUP' :: %+ %1 DUPUNROT %- NDXFext ; LCXMext
;
***********************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME SERIES
::
SERIESext
( a, lim, DL-l, reste-l, num-l/deno-l, equiv-l, lvar )
RCLVX DUPUNROT ' ID h MEVALext
( a, lim, DL-l, reste-l, num-l/deno-l, equiv-l, x, lvar[h] )
THREE
ZERO_DO (DO)
	ZERO 6ROLL 3PICK VAL2ext UNROT
	LOOP
( a, lim, DL-l, reste, num/deno, equiv, x, lvar[h] )
3PICK 5ROLL x*ext
( a, lim, DL-l, reste, equiv, x, lvar[h], DL )
4ROLL 5ROLL x*ext TWO{}N
( a, lim, DL-l, x, lvar[h], { DL reste-equiv } )
4ROLLDROP UNROTDROP ' ID h SWAP 
( a, lim, DL, h, x )
* si a=infini faire x=1/x, sinon x=x+a
5ROLL
::	DUPTYPESYMB?
	NOTcase x-ext ( h=x-a )
	DUP CARCOMP ' x\9F EQUAL
	NOTcase x+ext
	DROP ' xINV EvalNoCK
	;
' x= EvalNoCK
( lim, resultat, h[x] )
;
*************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME QXA
:: ( symb -> lvar, matrice )
CK1&Dispatch
symb :: QXAext
	( matr, lvar )
	TWO ROT
	( lvar, #2, matr )
	NULL{} VAL2ext SWAP
	( matr, lvar )
	;
;
******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME AXQ
::
CK1
DTYPENDO?
ITE VARGENext
     :: CK2NOLASTWD
        ( endo, lvar )
        SWAP DTYPENDO? NcaseTYPEERR
        ( lvar, endo )
        DUPLENCOMP ROT DUPLENCOMP
        ROT #= NcaseTYPEERR
        ;
( endo, lvar )
SWAP HXS 2 20 MPMULText
INNERCOMP DUP1LAMBIND NULL{} SWAP
ZERO_DO (DO)
        ( ln, ..., lk, {lk-1, ..., l1} )
        SWAPINCOMP DROP INDEX@ NDROP HXS 2 20 RDIVext HXS 1 0 INDEX@ NDUPN DROP
        1GETLAM {}N >HCOMP
        LOOP
ABND
OVER NOSIMPEVALext :: MVMULText XYext ; SIMP1ext
internalflag ClrUserFlag
;
****************************************
ASSEMBLE
         CON(1)  8
RPL
*xNAME XPRG
*::
*CK1&Dispatch
*real ::	CKNNOLASTWD ::N ;
*seco :: INNERCOMP UNCOERCE OVER EQ: x>> NcaseTYPEERR ;
*;
xNAME KERN
::
CK1 AXLext
CK&DISPATCH1
list :: DTYPFMAT? NcaseSIZEERR
	INNERCOMP SWAP VARGENext %1 >TCOMP ROTDUP
	ZERO_DO 
		( l1, ..., ln, v, #n )
		get1 %0 >TCOMP
		SWAPLOOP
	{}N SWAP
	( matr, lvar )
	SOLGENext ROTDROP ROTDROP
	;
;
*****************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME ILAP
::
CK1&Dispatch
symb 
::
( ILAP: symb -> symb )
LVARXNXext
( symb, x, lvarnx, lvarx )
DUPNULL{}? case2drop :: SYMBOL ID Delta ; ONE ' xFCNAPPLY FOUR SYMBN x*ext ;
3PICK ONE{}N EQUAL
( symb, x, lvarnx, lvarx={x}? )
NOTcase2drop :: SYMBOL xILAP ; ONE ' xFCNAPPLY FOUR SYMBN ;
( symb, x, lvarnx )
SWAP DUP1LAMBIND >HCOMP
( fraction rationnelle, lvar )
SIX PFext
( lvar, quotient, num1, f1, m1, ..., numk, fk, mk, #3k )
::	DUP#0=csedrp %0
	%0 SWAP THREE #/ SWAPDROP
	ZERO_DO (DO)
		( num1, f1, m1, ..., numk, fk, mk, res )
		4UNROLL %ABSCOERCE
		( num1, f1, m1, ..., res, numk, fk, #mk )
		complexflag TestUserFlag complexflag SetUserFlag
		3PICK EVIDENText SOLVext &COMP
		complexflag ROT ITE_DROP ClrUserFlag
		( result, numk, fk, #m, lrac )
* suppression des conjuguees si mode reel
		::	complexflag TestUserFlag ?SEMI
			INNERDUP
			( r1, ..., rn, #n, #n )
			ZERO_DO 
				( r1, ..., rk, #k )
				2DUP #2+UNROLL 
				( rk, r1, ..., rk, #k )
				SWAPDUP RCONJext DUPROT
				( rk, r1, ..., rk-1, #k, conj[rk], conj[rk], rk )
				::	
				EQUAL ?SEMI
				( rk, r1, ..., rk-1, #k, conj[rk] )
				OVER
				DUP#1= caseDROP
				ONE_DO	(DO)
					( rk, r1, ..., rk-1, #k, conj[rk] )
					ROT2DUP EQUAL
					( rk, r1, ..., rk-2, #k, conj[rk], rk-1, ? )
					::	
					casedrop 
					::	SWAP#1-SWAP ExitAtLOOP
						JSTOP@ #1- JSTOPSTO
						;
					3PICK #1+UNROLL
					;
					LOOP
				;
				( rk, r1, ..., rk-1, #k, conj[rk] )
				DROPLOOP
			{}N
			;
		SWAP
		( result, numk, fk, lrac, #m )
		::	DUP#1= casedrop
			::	( result, numk, fk, lrac )
				UNROTSWAP
				( result, lrac, fk, numk )
				FXNDext ROT RMULText DERext
				( result, lrac, numk, den' )
				THREE 4ROLL
				( result, numk, den', #3, lrac )
				INNERCOMP psh DROP
				( r1, ..., rn, #n, result, numk, den' )
				4ROLL
				ZERO_DO (DO)
					( r1, ..., rk, result, numk, den' )
					2SWAP 2OVER
					( r1, ..., rk-1, numk, den', rk, result, numk, den' )
					SWAP4PICK HORNext UNROT2DROP
					( ..., result, den', num[rk] )
					SWAP4PICK HORNext UNROT2DROP
					( ..., result, num[rk], den'[rk] )
					RDIVext ONE{}Next ROT
					( result, ck, rk )
LABEL ilapexp!
( ck, rk -> ck*exp[rk*x] )
::
HXS 1 0 TWO{}N TRIMOBJext
::	complexflag TestUserFlag case xEXPext
	DUP RREext xEXPext 
	( ck, rk, exp )
	UNROT RIMext 
	( exp, ck, rk )
	num#0=case DROPSWAP
	SWAP HXS 2 20 RMULText 
	( exp, rk, 2*ck )
	2DUP RREext SWAP xCOSext x*ext
	( exp, rk, 2*ck, re[ck]*cos )
	UNROT RIMext SWAP xSINext x*ext
	( exp, cos, sin )
	x-ext SWAP
	;
x*ext
; ( end ilaprk! )
					( ..., result, ck*exp[rk] )
					x+ext
					( r1, ..., rk-1, numk, den', result )
					UNROT
					LOOP
				2DROP
				;
			( result, numk, fk, lrac, #m )
			ROTOVER RPext
			( result, numk, lrac, #m, Q )
			4ROLLSWAP RDIVext FXNDext SWAP 4UNROLL
			( result, numk, lrac, #m, Q )
			4NULLLAM{} BIND
			3GETLAM LENCOMP
			#1+_ONE_DO (DO)
				( result )
				3GETLAM INDEX@ NTHCOMPDROP
				( result, rac )
				4GETLAM OVER 2GETLAM
				ZERO_DO (DO)
					( calcul du dvp Taylor ordre m-1 de P )
					HORNext UNROT
				LOOP
				2DROP
				( complement de 0 pour la div puiss croiss )
				HXS 1 0 2GETLAM #1- NDUPN DROP 
				2GETLAM #2* #1-{}N
				( result, rac, Taylor[P] )
				1GETLAM 3PICK 2GETLAM
				ZERO_DO 
					HORNext 
					DROPLOOP
				( result, Taylor[P], Q[m], rac )
				2GETLAM DUPDUP #+SWAP
				( result, rac, Taylor[P], Q[m], rac, #2m, #m )
				DO
				   ( calcul du dvp Taylor ordre 2m-1 de Q )
				   HORNext UNROT
				LOOP
				2DROP 2GETLAM {}N
				( result, rac, Taylor[P], Taylor[Q] )
				NEWDIVext DROP
				( result, rac, Taylor[P/Q] )
				FXNDext SWAP
				INNERDUP #1-SWAP
				ZERO_DO	
					get1 
					ISTOP-INDEX #1- UNCOERCE %FACT R2Zext
					RDIVext 
					SWAPLOOP
				#1+ {}N
				( result, rac, deno, Taylor modifie )
				SWAP RDIVext
				SWAP 
				( result, ck, rk )
		CODE
		A=PC
		LC(5)	(ilapexp!)-(*)
		A=A+C	A
		PC=(A)
		ENDCODE
				( result, ck*exp[rk*x] )
				x+ext
				LOOP
			ABND
			;
		LOOP
	;
( lvar, quotient, symb )
* creer les fonctions delta et derivees )
SWAP
::	NOTLISTcase DROP
	INNERCOMP DUP#0=csDROP
	"d1" "Delta" %0 4ROLL
	ZERO_DO (DO)
		( on, .., o0, prefixe, nom actuel, algebrique )
		4ROLL
		( on, .., o1, prefixe, nom actuel, algebrique, o0 )
		1GETLAM 4PICK $>ID symcomp ONE ' xFCNAPPLY FOUR SYMBN
		( on, .., o1, prefixe, nom actuel, algebrique, o0, 'delta[x]' )
		x*ext x+ext
		( on, .., o1, prefixe, nom actuel, algebrique )
		UNROT OVERSWAP &$ ROT
		( on, .., o1, prefixe, nom actuel, algebrique )
		LOOP
	UNROT2DROP
	( lvar, symb, algebrique )
	x+ext 
	;
ZEROSWAP ROT VAL2ext
( symb )
ABND
internalflag ClrUserFlag
;
;
*******************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME CIRC
::
CK2
SWAP CKPERMext SWAP CKPERMext
CIRCext
;
************************************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME C2P
::
CK1 C2Pext
;
***********************************************
ASSEMBLE
         CON(1)  8
RPL
xNAME P2C
::
( permutation -> decomposition en cycles )
CK1 CKPERMext P2Cext
;
**************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME DSOLVE
::
CK1&Dispatch
symb 
::
INNERCOMP OVER EQ: x= IT :: SWAPDROP ' x- SWAP ;
SYMBN
LVARext
( EQ LVAR ) 
DUP' ::	DUPLENCOMP NTHCOMPDROP 
	EQ: xFCNAPPLY
	;
Find1stTrue 
NcaseTYPEERR
( eq, lvar, fnc )
DUPDUP LENCOMP #2- NTHCOMPDROP CARCOMP
( eq, lvar, func, fnc_name )
ID>$ DUPONE TWO SUB$ "d1"
( eq, lvar, func, func_name, "ab", "d1" )
EQUALcase ::	THREE FOUR SUB$ "d1"
		EQUALcase ( 2nd ordre -> error ) SETSIZEERR
		( eq, lvar, func )
		SWAPDROP xEXEC 
		( 'd1f=...' )
		xOBJ> 2DROP SWAPDROP xDSOLVE
		;
DROP
DUP' xOBJ\-> EvalNoCK 1LAMBIND
%1 %= NcaseTYPEERR
( eq, lvar, fnc, var )
DUP STOVX
( eq, lvar, fnc, var )
ROTOVER EQUALPOSCOMP
( eq, fnc, var, position de x dans lvar si #0 alors incomplete en x )
#0=case ::	( y'=f[y]: eq, y[x], x )
		1GETLAM SWAP 1PUTLAM DUP4UNROLL MEVALext
		( y, f[y] )
		%1 SWAP NDXFext
		SWAP INText
		1GETABND DUP ID>$ CHR_0 >T$ $>ID x-ext
		"Incomplete" DSOLVTAGext
		;
TWO{}N
( EQ { FNC VAR } )
DUPDUP INNERCOMP
( EQ { FNC VAR } { FNC VAR } FNC VAR )
ZERO_DO 
	' ID t 'x* EvalNoCK
	SWAPLOOP
TWO{}N
( EQ { FNC VAR } { FNC VAR }{ t*FNC t*VAR })
4PICK UNROT MEVALext
( EQ { FNC VAR } t-EQ )
3PICK x-ext TSIMPext SIMP1ext
num0=case 
::	( HOMO ) 
	DROP ID t %1 TWO{}N MEVALext
	( F[Y;1] )
	ID t x-ext %1 SWAP NDXFext ID t INText xEXPext
	SYMBOL %1 xi ID t x* x+ ; 'x* EvalNoCK
	RCLVX 1GETABND SYMBOL xi ; SWAP' x* EvalNoCK x+ext
	SWAP' x= EvalNoCK
	"Homogene" ' ID ODETYPE STO
	;
( EQ { FNC VAR }, t-EQ ) 
DROP VXXLext 
( FNC; L-EQ )
FXNDext
( fnc, num, deno )
( teste variables separables )
SEPARext
( fnc, num, deno, [ deno-x, deno-y, TRUE | FALSE ] )
ITE ::	( fnc, num, deno, deno-x, deno-y )
	4PICK SEPARext
	( fnc, num, deno, deno-x, deno-y, num, [num-x, num-y TRUE | FALSE] )
	NOTcase2drop DROPFALSE
	( fnc, num, deno, deno-x, deno-y, num, num-x, num-y )
	4ROLLSWAP RDIVext
	( { y x }, num, deno, deno-x, num, num-x, fnc-y=deno-y/num-y )
	4UNROLL SWAPDROPSWAP RDIVext
	( { y x }, num, deno, fnc-y, fnc-x=num-x/deno-x )
	ROTDROP ROTDROPSWAP TRUE
	;
	FALSE
( fnc, fnct-x, fnct-y, TRUE | num, deno, FALSE ] )
case ::	( variables separables )
	ZEROSWAP 1GETLAM ONE{}N VALOBJext 1GETABND INText
	( fnc, fnct-x, int[fnct-y] )
	UNROT ZEROSWAP ROT CDRCOMP DUP4UNROLL VALOBJext
	SWAP CARCOMP INText x-ext
	"Separable" ' ID ODETYPE STO
	;
( fnc, num, deno )
DUPTYPELIST? 
ITE :: INNERCOMP
       DUP#1= casedrop ZERO
       DUPDUP #1+UNROLL
       ONE_DO (DO)
              HXS 1 0 EQUAL 
              NcaseSIZEERR
              LOOP 
       ;
    ZERO
ROT
( FNC; DENO,deg DENO, NUM )
DUPTYPELIST? ?SKIP ONE{}N
DUPLENCOMP TWO #> 3PICK #0<> ORcase 
:: ( BERNOUILLI? ) 
   INNERCOMP get1
   ( ..., CN; ...; C0; N+1; d )
   :: DUP#0=csedrp
     :: #1-SWAP
     TRIMOBJext HXS 1 0 EQUAL NcaseSIZEERR
     ( FNC, DENO; cN; ... ; c1; N )
     SWAPOVER #1+UNROLL
     ( FNC, DENO; c1; cN; ... ; N ) 
     DUP #2= ITE ROTSWAP
     :: DUP #1-SWAP OVER#2+UNROL
        ONE_DO (DO)
          TRIMOBJext HXS 1 0 EQUAL NcaseSIZEERR
          LOOP
        ( FNC, DENO; c1; N; cN )
        UNROT
        ;
     #1- UNCOERCE %CHS
     ;
   ( ..., CN; ...; C0; N+1; d )
   OVER #-+1 #0= NcaseSIZEERR
   ( ..., CN; ...; C0; N+1 )
   #1-SWAP OVER#2+UNROL
   DUP#1= case SETSIZEERR
   DUP #1-SWAP OVER#2+UNROL
   ZERO_DO (DO)
          TRIMOBJext HXS 1 0 EQUAL NcaseSIZEERR
          LOOP
   ( FNC, DENO; c0; cN; N )
   ROTSWAP
   UNCOERCE
   ;
   ( FNC, DENO; cN; c1; N )
   4UNROLL 3PICK NDXFext
   SWAPROT NDXFext TWO{}N
   ROT CDRCOMP SWAP 
   { ONE } FROMLISText OVERSWAP LOPMext
   ( 1-N; { L1; L0} )
   1GETLAM ID>$ CHR_0 >T$ $>ID 3PICK x^ext LINSOLVext
   ( 1-n, z )
   SWAP %2 EQUALcasedro xvext
   %-2 EQUALcasedro
   :: xvext %1 SWAP NDXFext ;
   %1 SWAP RDIVext x^ext
   1GETABND "Bernouilli" DSOLVTAGext
   ;
( LINEAIRE )
( FNC; DENO,deg DENO, NUM )
SWAPDROP
INNERCOMP #1= ITE HXS 1 0 SWAP
( FNC, DENO; C; A )
3PICK NDXFext SWAPROT NDXFext SWAP
TWO{}N SWAP CDRCOMP SWAP 
{ ONE } FROMLISText
1GETLAM ID>$ CHR_0 >T$ $>ID LINSOLVext
1GETABND "Lineaire" DSOLVTAGext
;
;
***************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME TSIMP
::
CK1&Dispatch
any :: CKFPOLYext TSIMPext ;
;
***************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME LAP ( Laplace de poly )
::
CK1&Dispatch
any :: CKFPOLYext QOBJext LAPext ;
; ( end xLAP )
***************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME HALFTAN
::
CK1&Dispatch
any :: { xCOS xSIN xTAN }
       {	
	:: %2 NDXFext xTANext %2 x^ext %1 OVER x-ext %1 ROT x+ext x/ext ;
	:: %2 NDXFext xTANext %1 OVER %2 x^ext x+ext NDXFext %2 x*ext ;
	:: %2 NDXFext xTANext %1 OVER %2 x^ext x-ext NDXFext %2 x*ext ;
	}
	MEVALext
	;
;
**************************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME IPP
::
CK2&Dispatch symbsym
::
( expr, u )
* on decompose expr1=expr2 en expr1 et expr2
SWAPDUP DUPTYPESYMB? NcaseTYPEERR
DUPLENCOMP NTHCOMPDROP EQ: x=
( u, expr, flag )
ITE :: ' xOBJ\-> EvalNoCK 2DROP ; DUP
( u, expr1, expr2 )
* on recherche dans expr2 une integrale
LVARext
' :: DUPLENCOMP NTHCOMPDROP EQ: x\.S_ALGEBRAIC ;
Find1stTrue NcaseSIZEERR
* recurseflag ClrUserFlag
( u, expr1, expr2, integrale )
DUP' xOBJ\-> EvalNoCK 2DROP
( u, expr1, expr2, int, inf, sup, u'*v, var )
DUP STOVX
SWAP 8ROLL
( expr1, expr2, int, inf, sup, var, u'*v, u )
DUPUNROT 4PICK DERIVext
( expr1, expr2, int, inf, sup, var, u, u'*v, u' )
NDXFext SIMP1ext
( expr1, expr2, int, inf, sup, var, u, v )
2DUP x*ext 
( expr1, expr2, int, inf, sup, var, u, v, u*v )
6PICK 6PICK PREVALext SIMP1ext
( expr1, expr2, int, inf, sup, var, u, v, [u*v] )
6UNROLL 3PICK DERIVext x*ext SIMP1ext
( expr1, expr2, int, [u*v], inf, sup, var, u*v' )
SWAP symcomp ' x\.S_ALGEBRAIC FIVE SYMBN
( expr1, expr2, int, [u*v], newint )
x-ext MEVALext ' x= EvalNoCK
;
;
**************************
ASSEMBLE
         CON(3)  000
RPL
xNAME \9F
::
CK0
real_intflag TestUserFlag NOTcase %MAXREAL
INFINIext ' xNEGNEG >TCOMP 
;
**************************
ASSEMBLE
	CON(1)	8
RPL
xNAME DIV
::
CK2&Dispatch
2LIST
::
CK2FPOLY INNERCOMP get1 INNERCOMP
( V1 V2 V3 #3 1 2 3 )
get1 OVER#= NcaseSIZEERR
internalflag SetUserFlag
( V1 ... VN F1 ... FN #N )
get1 ROTSWAP DERIVext
SWAPDUP
DUP#1= case2DROP
ONE_DO (DO)
	( V1 . VK F1 . FK DIV #K+1 )
	get1 4ROLLSWAP
	( V1 . VK-1 F1 . FK-1 DIV #K+1 VK FK )
	DERIVext ROT RADDext
	SWAP#1-
	LOOP
DROP
internalflag ClrUserFlag
;
;
*************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME CURL
::
CK2&Dispatch 2LIST 
::
CK2FPOLY INNERDUP #3= NcaseSIZEERR
get1
INNERDUP #3= NcaseSIZEERR
( V1 V2 V3 #3 1 2 3 )
internalflag SetUserFlag
get1 2DROP
( V1 V2 V3 1 2 3 )
DUP 6PICK DERIVext
( V1 V2 V3 1 2 3 D2_3 )
3PICK 6PICK DERIVext RSUBext
( V1 V2 V3 1 2 3 C1 )
4PICK 6ROLL DERIVext
( V1 V2 1 2 3 C1 D3_1 )
ROT 7PICK DERIVext RSUBext
( V1 V2 1 2 C1 C2 )
ROT 6ROLL DERIVext
( V2 1 C1 C2 D1_2 )
4ROLL 5ROLL DERIVext RSUBext
THREE{}N
internalflag ClrUserFlag
;
;
************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME LAPL
::
CK2&Dispatch SYMLIST 
::
CK2FPOLY NOTLISTcase SETSIZEERR
internalflag SetUserFlag
DUPUNROT DERIVext SWAP xDIV
internalflag ClrUserFlag
;
;
************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME HESS
::
CK2&Dispatch
# A5 ::	( fnct, lvar )
	CKFPOLYext
	internalflag SetUserFlag
	DUPUNROT DERIVext
	DUPROT DERIVext
	( gradient, hessien )
	internalflag ClrUserFlag
	;
;
***********************************
ASSEMBLE
	CON(1) 8
RPL
xNAME NORM
::
CK1&Dispatch
list :: CKFPOLYext
ZERO MONOEVALext
::	INNERCOMP HXS 1 0 SWAP
	ZERO_DO (DO)
		SWAPDUP RMULText RADDext
		LOOP
	XSQRext
	;
;
;
************************************
ASSEMBLE
	CON(3) 000
RPL
xNAME SINCOS
::
CK1&Dispatch
any :: CKFPOLYext QOBJext SINCOSext ;
;
************************************
ASSEMBLE
	CON(3) 000
RPL
xNAME TAN2SC2
::
CK1&Dispatch
any :: CKFPOLYext QOBJext TAN2SC2ext ;
;
************************************
ASSEMBLE
	CON(3) 000
RPL
xNAME TRIGCOS
::
CK1&Dispatch
any :: CKFPOLYext sincosflag ClrUserFlag
       QOBJext TRIGext
       ;
;
***********************************
ASSEMBLE
	CON(3) 000
RPL
xNAME TEXPA
::
CK1&Dispatch
any :: CKFPOLYext QOBJext TEXPAext ;
;
*************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME TRUNC
::
CK2
::	DUP LIDNText DUPNULL{}? caseSIZEERR
	CARCOMP STOVX
	TWO{}N VXLVARext VXXLext INCOMPDROP 'REVAL
	ZEROSWAP ROT VAL2ext
	;
::	DIVext SWAPDROP FXNDext
	DUPTYPELIST? IT CARCOMP
	DIVOBJext
	;
;
************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME DIVPC
::
CK3
positifflag SetUserFlag
dREALNcase SETSIZEERR
%ABSCOERCE UNROT RDIVext LVARext VXXLext
( ordre, lvar, n/d )
ROTSWAP FXNDext DIVPCext
( lvar, quot-n, quot-d )
DUPTYPELIST? IT CARCOMP
DIVOBJext
ZERO SWAPROT VAL2ext
internalflag ClrUserFlag
;
**********************************
ASSEMBLE
	CON(3) 000
RPL
xNAME LNCOLC
::
CK1&Dispatch
any ::	CKFPOLYext QOBJext LNCOLCext ;
;
**************************************
ASSEMBLE
	CON(1) 8
RPL
xNAME SOLV
::
CK2 CK2FPOLY
isolflag ClrSysFlag ISOL2ext
;
**************************************
ASSEMBLE
         CON(3)  000
RPL
xNAME EXPLN
::
CK1&Dispatch
any EXPLNext
;
**********************************
ASSEMBLE
	CON(1) 8
RPL
xNAME SCROLL
::
CK1&Dispatch
grob SCROLLext
;
***********************************
ASSEMBLE
         CON(1)  8
RPL
xNAME FSIGN
::
CK1&Dispatch
sym ::	positifflag ClrUserFlag
	complexflag TestUserFlag
	complexflag SetUserFlag
	SWAP ZERO RFACText
	complexflag 5ROLL ITE_DROP ClrUserFlag
	( lvar, obj interne, liste racines internes )
	ONESWAP 4PICK CDRCOMP
	( lvar, obj interne, #1, liste racines internes, lvar )
	DUPNULL{}? NcaseSIZEERR VAL2ext
	( lvar, obj interne, liste racines )
	SWAP POSITIFext SWAPDROP ITE { x+ } { x- }
	( lvar, liste racines, resultat )
	SWAPINCOMP DUP#0=csDROP
	DUP1LAMBIND #2/ 
	#1+_ONE_DO (DO)
		%2 %MOD %0= TWO{}N 1GETLAM INDEX@#- UNROLL
		LOOP
	1GETABND #2/ {}N
	' ::	CARCOMP CRUNCH DUPTYPEREAL? NOTcase2drop TRUE
		SWAP CARCOMP CRUNCH DUPTYPEREAL? NOTcase2drop TRUE
		%<
		;
	SortList
	( lvar, resultat, liste racines/?multiplicite paire )
	INNERCOMP get1 SWAP
	ZERO_DO	(DO)
		( { r1, flag1 }, ..., { rk, flagk}, { signes } )
		::	SWAPINCOMP DROPOVER CRUNCH TYPEREAL?
			( {r1, flag1}, ..., { signes }, rk, flagk, ?reel )
			NOTcase2DROP
			( r1, flag1, ..., { signes }, rk, flag )
			3PICK CARCOMP SWAP
			( r1, flag1, ..., { signes }, rk, signe, flagk )
			?SKIP
		CODE
		A=DAT1	A
		LC(5)	=x+
		?A#C	A
		GOYES	write
		LC(5)	=x-
write		DAT1=C	A
		GOVLNG	=Loop
		ENDCODE
			SWAP TWO{}N SWAP &COMP
			;
		LOOP
	( lvar, resultat )
	SWAP CARCOMP DO>STR >TAG
	;
;
**********




