#  (c) 07/1998 Bernard Parisse, 
#  Institut Fourier, Universit\'e de Grenoble I, 
#  F-38402 St Martin d'Heres
#  This file is part of the ERABLE package.
#  See copying.doc for licensing information

# header
KERNEL.LIB: kernellib binhd khash.h
	cat binhd kernellib > KERNEL.LIB
	zip erable.zip KERNEL.LIB
# sload
kernellib: kernel.m kernellib.o
	sload -e -H kernel.m
# makerom
k.m: k.mn kextdec.h kromid.h
	makerom k.mn k.m
khash.h: k.m kextdec.h kromid.h
	echo "ASSEMBLE" > khash.h
	awk -f equ.awk khash0.a  >> khash.h
	echo "RPL" >> khash.h
khash.a: k.m kextdec.h kromid.h
	awk -f end.awk khash0.a > khash.a
khead.a: k.m kextdec.h kromid.h
	awk -f end.awk khead0.a > khead.a
kend.a: k.m kextdec.h kromid.h
	cp kend0.a kend.a
# sasm
kernellib.a: khead.a kernel.a khash.a kend.a kextdec.h kromid.h
	cat khead.a kernel.a khash.a kend.a > kernellib.a
kernellib.o: kernellib.a kextdec.h kromid.h
	sasm -e kernellib.a
khash.o: khash.a kextdec.h kromid.h
	sasm -e khash.a

# rplcomp
kernel.a: kuser.s kernel.s kcfg.s kextdec.h kromid.h
	cat kuser.s kernel.s kcfg.s > tmp.s
	rplcomp tmp.s kernel.a kernel.ext

