* -*- mode:Mail -*-
*  (c) 07/1998 B. Parisse, except the ML programs
*  HORN%%ext and BAIRSText (c) 06/1995 Ram Naresh Gudavalli
*
*  This file can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This file is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this file; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

*  To build the SX version of erable:
*  Step 1: get erablsrc.zip, unzip it and type compile
*  Step 2: edit erable.s, search for ersolv.g, replace ersolv.g by ersolv.s
*  Step 3: type make


*INCLUDE alromid.h
*INCLUDE alextdec.h
*INCLUDE keydefs.h
*INCLUDE alhash.h
*INCLUDE global.s

*ASSEMBLE
*        NIBASC /HPHP48-D/
*RPL
*DEFINE sincosflag       EIGHTEEN

::
* Routine de factorisation pour S/SX
( polynome ou polynme-liste, epsilon, nombre d'itrations -> liste des racines )
* Factorise un polynme-liste  coeffcients rels ou complexes
* par la mthode de Laguerre ou de Bairstow.
DUPLENCOMP FOUR #<case DEG2ext

( 6     5      4     3   2      1    )
"HALT" "RAND" NULL$ DUP "/10" "*10"
MENUext
* test l'entree directe
:: NOTLISTcase UNROTSWAP
   ( test et nombre d'itrations aprs le test )
   THREE RCLEPS 3PICK LENCOMP UNCOERCE %* ROT
   ;
( #iterations, epsilon, liste )

NULL{} SWAP TRIMext 

* conversion des coeff au format long
INNERDUP #1-SWAP
' :: 	CK&DISPATCH1
	real	%>%%
	ereal	NOP
	hxs	:: Z>R %>%% ;
	cmp	C%>C%%
	ecmp	NOP
	seco	::	INNERCOMP #2= NcaseTYPEERR
			CK&DISPATCH1
			# BB	ZZ2C%%ext
			;
	;
1LAMBIND
ZERO_DO
	get1 FXNDext
	1GETLAM EVAL SWAP 1GETLAM EVAL
	SWAP RDIVext
	SWAPLOOP
#1+ {}N
ROT 1GETLAM EVAL UNROT 
ABND
		
( #iterations, epsilon, root-list, P-liste )
DUPLENCOMP TWO #< casedrop UNROT2DROP
****************************************************
( assignation des LAM )
' :: ( LAM10 2%%RANext : o1, o2 -> %%, o1, o2, %% )
     %RAN %.5 %- %>%% UNROT %RAN %.5 %- %>%%
     ;
' :: ( LAM9: polynome de degr 1, 2 ou 3 -> racines )
     DUPLENCOMP
     DUP#0=csDROP
     FOUR #=casedrop
     :: DUPTWO NTHCOMPDROP %%3 %%/ %%CHS DUPUNROT 7GETLAM EVAL DUP
        INCOMPDROP ROTDROP
        3PICK %%2 %%* %%/ %%CHS SWAPROT %%3
        %%* %%/ DUP 2DUP %%* %%* 3PICK DUP %%* %%+
        DUP %%0>=
        case :: SWAPDROP %%SQRT 2DUP %%+ UNROT %%-
                ' ::  DUP %%0= ?SEMI DUP %%0>
                      DUPUNROT ?SKIP %%CHS %%LN %%3 %%/
                      %%EXP SWAP ?SKIP %%CHS
                      ;
                DUPUNROT EVAL UNROT EVAL %%+
                8GETLAM EVAL DROP 3PICK %%+ UNROT
                SWAP %%CHS 7GETLAM EVAL 9GETLAM EVAL SWAP >TCOMP
                ;
        DROP %%CHS %%SQRT DUP %%2 %%*UNROT DUPDUP %%* %%* %%/
        DUP %%ABS %%1 %%>
        ITE :: %%0>= ITE %%0 %%2PI %%2 %%/ ;
            %%ACOSRAD
        THREE
        ZERO_DO (DO)
                %%2PI %%+ 2DUP %%3 %%/ %%COSRAD %%* 5PICK %%+ 5UNROLL
                LOOP
        4DROP THREE{}N
        ;
     #>2case :: ( degr\'e 2 { a, b, c } ) 
	        DUP CARCOMP
		CK&DISPATCH1
		SIXTYTHREE 
	        ::	
	        DROPDUP INCOMPDROP
                3PICK %%/ SWAPROT %%2 %%* %%/ %%CHS DUPDUP %%*ROT
                %%- DUP %%0>=
                case :: %%SQRT 2DUP %%+ UNROT %%-
                        TWO{}N SWAPDROP
                        ;
                complexflag TestUserFlag
                NOTcase2drop :: NULL$ >TAG ONE{}N
                                ;
                %%CHS %%SQRT 2DUP %%CHS %%>C%% UNROT
                %%>C%% TWO{}N SWAPDROP
	        ;
	        any :: DROP DEG2ext ;
                ;
     ( degre 1) INCOMPDROP SWAP %%/ %%CHS ONE{}N
     ;
( LAM 8 HORN%%ext )
' ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
* Schma de Horner pour des %%
:: ( P, %% )
   TOTEMPSWAP TOTEMPOB DUPLENCOMP
   ( %%, P, # )
   ROTSWAP
   ( P, %%, # )
   DUP#1=
   casedrop :: SWAP CARCOMP { %%0 } UNROT
               ;
   ( P, %%, # )
CODE
  GOSBVL  =POP#
  GOSBVL  =SAVPTR
  A=A-CON A,2
  R4=A.F  A
  SETDEC
  A=DAT1  A
  D1=D1+  5
  C=DAT1  A
  D1=A
  D1=D1+  5
  GOSBVL  =GETAB1	A[A]: r
  GOSBVL  =STAB0
  D0=C
  D0=D0+  10
  GOSBVL  =GETCD0
  GOSBVL  =MULTF
  AR4EX
Mainloop
*********************************
  AR4EX
  D0=D0+  5
  GOSUB   Read%%CD
  GOSUB   saveD0
  GOSBVL  =RADDF
  GOSUB   getD0
  GOSBVL  =PUTAB0
  GOSBVL  =RCCD0
  GOSBVL  =MULTF
  AR4EX
  A=A-1   A
  GONC    Mainloop
*********************************
  SETHEX
  P=      0
  GOVLNG  =GETPTRLOOP

Read%%CD
  GOSBVL  =GETCD0
  D0=D0-  16
  D0=D0-  5
  RTN

saveD0
  AD0EX
  D1=A
  AD0EX
  RTN

getD0
  AD0EX
  AD1EX
  AD0EX
  RTN
ENDCODE
    SWAPINCOMP DUPUNROT #2+UNROLL
    #1-{}N
    UNROTSWAP
    ;
( LAM 7 PTAYL%%ext )
' :: OVER LENCOMP
     ( P r #n )
     DUP4UNROLL
     ZERO_DO (DO)
             8GETLAM EVAL 4UNROLL
             LOOP
     2DROP reversym {}N
     ;

( LAM 6 BAIRSText )
( polynome-liste P, s ,p -> P[X] div [X*X-sX+p] & R[X-s], s, p )
* Division euclidienne par un polynome quadratique
' ( P, s, p, # -> P div X^2-s*X+p & P mod X^2-s*X+p, s, p )
CODE
size2  EQU  7

  ST=0    size2
  GOSBVL  =POP#
  A=A-CON A,2
  ?A#0    A
  GOYES   Notsize2
  ST=1    size2
Notsize2
  A=A-1   A
  R4=A.F  A
  GOSBVL  =SAVPTR
  SETDEC
  A=DAT1  A
  D1=D1+  5
  C=DAT1  A
  D0=C
  D0=D0+  5
  GOSBVL  =GETCD0
  GOSBVL  =STCD0
  D0=A
  D0=D0+  5
  GOSBVL  =GETAB0
  GOSBVL  =STAB2
  D1=D1+  5
  A=DAT1  A
  D1=A
  D1=D1+  10
  GOSBVL  =GETAB1
  GOSBVL  =MULTF
  D1=D1+  5
  GOSUB   ReadCD1
  GOSBVL  =RADDF
  GOSUB   PUTAB1
  ?ST=0   size2
  GOYES   NotEnd
  GOTO    End
NotEnd
  AR4EX.F A
MainLoop
*********************************
  AR4EX.F A
  D1=D1-  16
  D1=D1-  16
  D1=D1-  16
  D1=D1-  4
  GOSBVL  =GETAB1
  GOSBVL  =RCCD2
  GOSBVL  =MULTF
  A=-A-1  S
  D1=D1+  16
  D1=D1+  15
  GOSUB   ReadCD1
  GOSBVL  =RADDF
  GOSUB   PUTAB1
  D1=D1-  16
  D1=D1-  16
  D1=D1-  16
  D1=D1-  4
  GOSBVL  =GETAB1
  GOSBVL  =RCCD0
  GOSBVL  =MULTF
  D1=D1+  5
  GOSUB   ReadCD1
  GOSBVL  =RADDF
  GOSUB   PUTAB1
  AR4EX.F A
  A=A-1   A
  GONC    MainLoop
*********************************
End
  SETHEX
  P=      0
  GOVLNG  =GETPTRLOOP

ReadCD1
  D1=D1+  5
  C=DAT1  W
  D=C     W
  D1=D1-  5
  C=DAT1  A
  RTN

PUTAB1
  DAT1=A  A
  D1=D1+  5
  ABEX    W
  DAT1=A  W
  ABEX    W
  D1=D1+  15
  DAT1=A  S
  D1=D1+  6
  RTN
ENDCODE
     ( liste P div & R, s, p )

'  :: ( LAM 5: s, p, P , #5 -> s, p , P )
      DROP UNROT2DROP
      ( P )
      DUPINCOMP DROP 4ROLLDROP 4ROLLDROP ( P, c,d,e)
      2DUP 5PICK %%2 %%CHS %%/ TOTEMPOB UNROT ( P, c,d,e,-c/2,d,e )
      %%CHS TOTEMPSWAP ( P, c,d,e,-c/2,-e,d )
      6PICK 5PICK %%* TOTEMPOB ( P,c,d,e,-c/2,-e,d,ce )
      SWAPDUP %%* %%4 %%/ %%- %%2 %%/ TOTEMPOB
      %%1 TOTEMPOB 4UNROLL
      ( P,c,d,e,1,-c/2,-e,-d^2/8+ce/2)
      FOUR {}N 9GETLAM EVAL DUPLENCOMP NTHCOMPDROP
      ( P, c,d,e,a)
	DUP %%2 %%* 5ROLL %%- %%ABS %%SQRT
      ( P, d,e,a,sqrt[2a-c] )
      4ROLL %%0>= ?SKIP %%CHS
      ( P, e,a, s )
      4UNROLL DUPDUP %%* ( s,P,e,a,a^2 )
      ROT %%- %%ABS %%SQRT %%+ SWAP ( %%decal #it eps {rac}, s,p,P)
      TRUE
      ;
( LAM4: liste des touches->actions pour Baistow )
( decal it eps [rac] s Po B p %%test -> mme schma de pile )
{ kcMenuKey1
  :: ( Epsilon * 10 )
     7ROLL %%10 %%* "=" OVER
     %%>% DO>STR &$ DISPROW1 7UNROLL
     ;
  kcMenuKey2
  :: ( Epsilon / 10)
     7ROLL %%10 %%/ "=" OVER
     %%>% DO>STR &$ DISPROW1 7UNROLL
     ;
  kcMenuKey5
  :: ( Random s and p )
     2DROP ROTDROP 10GETLAM EVAL %%1
     ;
  kcMenuKey6
  :: ( Stop ) DROP %%0 TOTEMPOB 8PICK INDEXSTO ;
  }
( LAM3: liste des touches->actions pour Laguerre )
{ kcMenuKey1
  :: ( Epsilon * 10 )
     TWELVE ROLL %%10 %%* "= " OVER %%>% DO>STR
     &$ DISPROW1 TWELVE UNROLL
     ;
  kcMenuKey2
  :: ( Epsilon / 10)
     TWELVE ROLL %%10 %%/ "= " OVER %%>% DO>STR
     &$ DISPROW1 TWELVE UNROLL
     ;
  kcMenuKey5
  :: ( Random ) TEN ROLL DROP
     10GETLAM EVAL %%>C%% TEN UNROLL
     ;
  kcMenuKey6 ( Stop ) DROPFALSE
  }
'   :: ( LAM2: Laguerre: #it, epsilon, root-list, P-liste )
       ( -> #it, epsilon, root-liste, P-liste )
	complexflag SetUserFlag
	( transformation de reels longs en complexes longs )
	' ::	CK&DISPATCH1
		ereal	:: %%0 %%>C%% ;
		ecmp	NOP
		;
	1LAMBIND LISTSECOext ABND
	( fin de transformation )
       C%% 0 0 SWAP
       BEGIN
            DUPLENCOMP
            { DUP#1- #>$ EIGHT TWO &$SWAP &$ DISPROW5
              SIX SEVEN &$ DISPROW6 }
            User1IT
            THREE #>
       WHILE
            %%1 UNROT DUPLENCOMP  #1- UNCOERCE%% DUP %%1 %%- 2DUP %%*
		%%2  %%*
            BEGIN
		4PICK 6PICK 1GETLAM EVAL UNROT 1GETLAM EVAL TEN ROLL %%ABS
		DUP %%>% DO>STR DISPROW7 TWELVE PICK %%>
		GETTOUCH
		IT :: 3GETLAM EQLookup NOTcaseDROP EVAL
                       ;
            WHILE
                UNROT 1GETLAM EVAL UNROT2DROP 3PICK C%%C*C
                4PICK C%%C*R OVER 6PICK C%%C*R DUP C%%C*C SWAP C%%C-C
                C%%SQRT
		2DUP C%%C+C UNROT C%%C-C DUP C%%ABS 3PICK C%%ABS %%>
		IT SWAP
		DROPDUP C%%ABS %%0=
                :: case2drop :: 10GETLAM EVAL %%>C%% ; 
		   C%%C/C 4PICK C%%C*R
                   ;
                DUP 7UNROLL 6ROLL SWAP C%%C-C 5UNROLL
            REPEAT
            4ROLLSWAP C%%C/C C%%C-C 5UNROLL 4DROP
            { DUP C%%>C% DO>STR DISPROW4 } User1IT
            4ROLLOVER >TCOMP 4UNROLL 1GETLAM EVAL 2DROP
       REPEAT
       SWAPDROP
       ( fin de Laguerre )
       ;
( LAM1 HORNext )
RESOROMP HORNext
' NULLLAM TEN NDUPN DOBIND
*********************************************
( #itrations, epsilon, root-list, P-liste )
DUP CARCOMP 5UNROLL ( sauvegarde dnominateur )
( a0, #it, epsilon, root-liste, liste )
{ BlankDA12 "SOLV, =" 4PICK %%>% DO>STR &$ DISPROW1
  DUP ONESWAP NULL{} VAL2ext DO>STR DISPROW2
  THREE TWO &$ DISPROW3
  }
User1IT
DUPINCOMP FALSE SWAP
ZERO_DO (DO) ( Teste s'il y a un complexe dans la liste )
        SWAP XEQTYPE SWAPDROP %22 %= OR
        LOOP
( a0, #it, epsilon, root-liste, liste , true ou false )
ITE 2GETEVAL
    :: ( Bairstow )
       ( a0, #it, epsilon, root-liste, P-liste )
	DUP CARCOMP ' :: %%/ TOTEMPOB ; LOPAext
       ( a0, #it, epsilon, root-liste, P-liste )
       %%0 TOTEMPOB DUPDUP 7UNROLL ROT
          BEGIN
               ( pile = %%decal, #it eps [rac] s p P )
               DUPLENCOMP #1- OVER TWO NTHCOMPDROP
               ( conditionne le polynme: somme des racines=0 )
               SWAP UNCOERCE%% %%/ %%CHS DUPUNROT 7GETLAM EVAL
               ( %%decal, #it eps {rac} s p %%-newdecal P )
               8ROLL ROT %%+ 7UNROLL
               ( %%decal #it eps {rac} s p P )
               DUPLENCOMP
               { DUP#1- UNCOERCE DUP %1- DO>STR "," &$SWAP DO>STR &$
                 EIGHT TWO &$SWAP &$ DISPROW6 }
               User1IT
               DUP FIVE
               #=ITE :: 5GETLAM EVAL ;
                     :: FOUR #> ;
          WHILE
               6PICK ( nombre d'itrations ) DUP ( remplace poly B)
               ZERO_DO (DO) ( 2 itrations aprs le test < EPS )
                       ( [rac], s, p, poly, deflated_poly )
                       DROPDUP 2SWAP
                       ( [rac], poly, poly, s, p )
                       TOTEMPOB UNROT TOTEMPOB UNROT TOTEMPOB
                       ( [rac], poly, s, p, poly )
                       DUP4UNROLL LENCOMP DUP 5UNROLL
                       ( [rac], poly, #, poly, s, p, # )
                       6GETLAM EVAL ( BAIRSText )
                       ( [rac], poly, #, Q, s, p )
                       3PICK TOTEMPOB 4UNROLL 5ROLL 6GETLAM EVAL
                       ( [rac] poly Q R s p )
                       2SWAP
                       ( [rac] poly s p Q R )
                       INNERCOMP SWAPDROP #4- 4UNROLL THREE psh NDROP DROP
                       ( [rac] poly s p Q c[n-3] c[n-2] c[n-1] )
                       4ROLL INNERCOMP #2- UNROT TWO psh {}N SWAPDROP 8UNROLL
                       ( [rac] poly deflated_poly s p c[n-3] c[n-2] c[n-1] b[n-1] b[n] )
                       ( correction de c[n-1]:=c[n-1]-b[n-1] )
                       ROT 3PICK %%- UNROTDUP
                       ( S=b[n]*c[n-3]-b[n-1]*c[n-2] )
                       6PICK %%* 3PICK 6PICK %%* %%-
                       ( [rac] poly deflated_poly s p c[n-3] c[n-2] c[n-1] b[n-1] b[n] S )
                       ( P=b[n]*c[n-2]-b[n-1]*c[n-1] )
                       SWAP 5PICK %%* ROT 4PICK %%* %%-
                       ( [rac] poly deflated_poly s p c[n-3] c[n-2] c[n-1] S P )
                       ( D=c[n-2]^2-c[n-1]*c[n-3] )
                       2SWAP 5ROLL %%* SWAPDUP %%* SWAP %%-
                       ( [rac] Po deflated_poly s p S P D )
                       DUP %%0=
                       ITE :: DROP %RAN %.5 %- %>%% ;
                           %%1/
                       ( [rac] Po B s p S P D^-1 )
                       DUPROT %%*UNROT %%*
                       ( [rac] Po B s p Dp Ds )
                       DUP %%ABS 3PICK %%ABS %%+ 5UNROLL
                       ( [rac] Po B |Dp+Ds| s p Dp Ds )
                       UNROT %%+ UNROT %%+
                       ( [rac] Po B |Dp+Ds| p s )
                       DUP 6UNROLL %%ABS
                       ( [rac] s Po B |Dp+Ds| p |s| )
                       OVER %%ABS %%+ ROTSWAP
                       ( decal it eps [rac] s Po B p |Dp+Ds| |s|+|p| )
                       DUP %%0=
                       ITE :: 3DROP ROTDROP 10GETLAM EVAL ZERO INDEXSTO ;
                           :: %%/
                              { TWENTYSIX OVER %%>% DO>STR &$ DISPROW7 }
                              User1IT
                              ( decal it eps [rac] s Po B p %%test )
                              GETTOUCH
                              IT :: 4GETLAM EQLookup NOTcaseDROP EVAL
                                    ;
                              7PICK %%>
                              NOT?SEMI
                              ZERO INDEXSTO
                              ;
                       UNROT
                       LOOP
               SWAPDROP ( [rac] s p B )
               3PICK %%2 %%/ DUPDUP %%*
               ( [rac] s p B .5*s .25*s^2 )
               4PICK %%- DUP %%0>=
               ( %%decal #it eps {rac} s p B .5*s delta >=0? )
               ( 9        8  7    6    5 4 3  2    1 )
               ITE :: %%SQRT 2DUP %%+ TEN PICK %%+
                      UNROT %%- NINE PICK %%+ TRUE ;
                   :: complexflag TestUserFlag
                      NOTcase2drop :: %%1 TOTEMPOB
                                      4PICK %%CHS TOTEMPOB
                                      4PICK THREE{}N
                                      8PICK %%CHS 7GETLAM EVAL FALSE
                                      ;
                      SWAP NINE PICK %%+ SWAP %%CHS %%SQRT
                      2DUP %%CHS %%>C%% UNROT %%>C%% TRUE
                   ;
               ( [rac] s p B r1 r2 true ou [rac] s p B {poly} false )
               ITE ::	{ DUP %%>% DO>STR DISPROW4 OVER %%>% DO>STR DISPROW5 } 
			User1IT
			6ROLL INNERCOMP #2+
			;
                   ::	{ DUP ONESWAP NULL{} VAL2ext DO>STR DISPROW4 
			NULL$ DISPROW5 } User1IT
			5ROLL INNERCOMP #1+
			;
               {}N 4UNROLL
          REPEAT
          ( %%decal #it eps {rac} s p P )
          UNROT2DROP
          ( %%decal #it eps {rac} P )
          5ROLL %%CHS 7GETLAM EVAL
          ( #it eps {rac} P )
          ( fin de Bairstow )
          ;
real_intflag TestUserFlag real_intflag ClrUserFlag
SWAP 9GETLAM EVAL real_intflag ROT
ITE SetUserFlag ClrUserFlag
ABND
SWAP &COMP
UNROT2DROP
DispMenu.1

( reconstruction des racines sous forme formelle si possible )
complexflag TestUserFlag real_intflag TestUserFlag AND
NOTcase SWAPDROP
# 31415 JstGETTHEMSG displayflag UserITE DISPROW7 DROP
NULL{} UNROT
( froot-l, deno, nroot-l )
:: INNERDUP FOUR #<case :: {}N SWAPDROP ;
   get1 OVER
   ( formal-root-list, allroots, #n, deno, #n )
   BEGIN
          ( formal-root-list, allroots, #racines, deno, #racines_a_tester )
          4ROLLOVER
          ( formal-root-list, roots, #n, deno, #t, rk, #t )
          ONE_DO (DO)
          :: ( formal-root-list, roots, #n, deno, #t, rk )
             5ROLL 2DUP 2DUP RADDext RNEGext
             ( formal-root-list, roots, #n, deno, #t, rk, rl, rk, rl, -rk-rl )
             7PICK RMULText UNROT RMULText
             ( formal-root-list, roots, #n, deno, #t, rk, rl, -rk-rl, rk*rl )
             6PICK RMULText 6PICK UNROT
             ( froot-list, roots, #n, deno, #t, rk, rl, deno, -rk-rl, rk*rl )
             THREE{}N
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list )
             DUP 
		' ::	CK&DISPATCH1
			ereal	::	%%>% %0 RNDXY %>%% ;
			ecmp	::	C%%>%% 1GETLAM EVAL 
					SWAP 1GETLAM EVAL
					SWAP %%>C%%
					;
			hxs	NOP
			;
		1LAMBIND LISTSECOext ABND
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list, P-list rnd )
             SWAPOVER RSUBext ELMGext TRIMOBJext HXS 1 0 EQUAL
             ( froot-list, roots, #n, deno, #t, rk, rl, P-list, flag )
             NOTcasedrop :: 3PICK #3+ UNROLL ;
             UNROT2DROP ONESWAP NULL{} VAL2ext NULL{} VXXLext SWAPDROP DEG2ext
             ( froot-list, roots, #n, deno, #t, P-list )
             4ROLL DUP #3+ ROLL
             ( roots, deno, #t, P-list, #n, froot-list )
             ROT &COMP OVER#2+UNROL
             ( froot-list, roots, deno, #t, #n )
             #2- ExitAtLOOP
             ( froot-list, roots, deno, #t, #n-2 )
             UNROT #1-
             ( froot-list, roots, #n-2, deno, #t-1 )
             4ROLL
             ( froot-list, roots, #n-2, deno, #t-1, rk' )
             ;
             LOOP
          ( froot-list, roots, #n, deno, #t, rk )
          4PICK #3+ UNROLL #1-
          ( froot-list, roots, #n, deno, #t-1 )
          ( en fait #n, #t -> #n-2,#t-2 si 2 racines sont trouves )
          ( ou -> #n, #t-1 si aucune racine formelle n'est trouve )
          DUPTWO #<
   UNTIL
   ( froot-list, roots, #n, deno , #t )
   ( ou zero, froot-list, deno, #t )
   2DROP NOTLISTcase {}N SWAPDROP RDROP
   ( froot-list, {roots} )
   ;
* conversion des racines non formelles au format interne, inutile
* NULL{} VXXLext SWAPDROP
SWAP DUPNULL{}? NOTcase &COMP
DROP real_intflag ClrUserFlag
;