* -*- mode:Mail -*-
*  (c) 07/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file is part of the ERABLE package.
*  See copying.doc for licensing information

INCLUDE erromid.h
INCLUDE erextdec.h
INCLUDE erhash.h
INCLUDE kextdec.h
INCLUDE keydefs.h
INCLUDE kromid.h
INCLUDE global.s

*****************************************************************
* The user module contains the "xNames" - the user words.  These
* will be visible to the user.  The nibble that precedes each
* xName tells the parser that this is a non-algebraic.  Note that
* the user words are specified with the compiler directive
* "xNAME".
*****************************************************************
**********************************************************************
* Name:		xMOD+
* Desc:		Modular addition
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODADD
::
CK2
ZERO BINEVALext :: RCLMODULO ModAdd ;
;
**********************************************************************
* Name:		xMOD-
* Desc:		Modular substraction
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODSUBT
::
CK2
ZERO BINEVALext :: RCLMODULO ModSub ;
;
**********************************************************************
* Name:		xMOD*
* Desc:		Modular multiplication
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODMULT
::
CK2
ZERO BINEVALext :: RCLMODULO ModMul ;
;
**********************************************************************
* Name:		xMOD/
* Desc:		Modular division
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODDIV
::
CK2
BIN2EVALext :: RCLMODULO ModDiv ;
;
**********************************************************************
* Name:		xMOD^
* Desc:		Modular power
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODPOW
::
CK2
ZERO BINEVALext
:: RCLMODULO 1LAMBIND ' :: 1GETLAM ModMul ; MPext ABND ;
;
**********************************************************************
* Name:		xMODINV
* Desc:		Modular inverse
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME MODINV
::
CK1 RCLMODULO CK2Z
ModInv Z>S
;
********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME PA2B2
::
CK1 CK1Z
SUMSQRext
SWAPDROP ZEROSWAP NULL{} VAL2ext
;
**********************************************************************
