* -*- mode:Mail -*-

        TITLE Repertoire compl\'ementaire

*  (c) 07/1998 Bernard Parisse, 
*  Institut Fourier, Universit\'e de Grenoble I, 
*  F-38402 St Martin d'Heres
*  This file can be redistributed and modified under the terms of
*  the GNU General Public License as published by the Free Software
*  Foundation either version 2.0 or (at your option) any later version*

*  This file is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.

*  You should have received a copy of the GNU General Public License
*  along with this file; if not, write to the Free Software
*  Foundation, Inc, 675 Mass Ave, Cambridge, MA 02139, USA.

INCLUDE erromid.h
INCLUDE erextdec.h
INCLUDE kextdec.h
INCLUDE keydefs.h
INCLUDE khash.h
INCLUDE erhash.h

*
* Rpertoire ALGB d'installation
* Ne pas oublier de modifier le checksum dans INIT
*

ASSEMBLE
        NIBASC /HPHP48-D/
RPL
ASSEMBLE
            CON(5) #02A96 ( DORRP )
            CON(3) #7FF   ( NO LIB attached )
debut       CON(5) (dernier)-(debut)
            CON(5) #00000 ( le premier objet suit )



*******************************************************************
***************     SXL
            CON(2) ((SXLfin)-(SXLdeb))/2
SXLdeb   NIBASC /SXL/
SXLfin   CON(2) ((SXLfin)-(SXLdeb))/2
RPL
::
CK1NOLASTWD
CK&DISPATCH1
list :: CKFPOLYext
        DUP CARCOMP
        CK&DISPATCH1
        ELEVEN :: DROP DUPLENCOMP #2+ UNCOERCE CKNNOLASTWD DROP
                  QOBJext HXS>#
                  FROMLISText
                  ;
        any :: DROP RCLVX VALext ;
        ;
ELEVEN :: internalflag ClrUserFlag #>% CKNNOLASTWD TOLISText
          ;
any :: DUP FXNDext
       :: CK&DISPATCH1
          list TRUE
          EIGHTY TRUE
          any FALSE
          ;
       UNROT2DROP RCLVX SWAP
       case VALext VXXLext
       ;
;
ASSEMBLE
SXL      CON(5) (SXL)-(SXLdeb)+2
***************    SXL
*******************************************************************
*********


*******************************************************************
***************     S2L
            CON(2) ((S2Lfin)-(S2Ldeb))/2
S2Ldeb   NIBASC /S2L/
S2Lfin   CON(2) ((S2Lfin)-(S2Ldeb))/2
RPL
::
CK2NOLASTWD
VXXLext
NOTLISTcase NOP
ONESWAP NULL{} VAL2ext
;
ASSEMBLE
S2L      CON(5) (S2L)-(S2Ldeb)+2
***************    S2L
*******************************************************************
*********

*******************************************************************
***************     L2S
            CON(2) ((L2Sfin)-(L2Sdeb))/2
L2Sdeb   NIBASC /L2S/
L2Sfin   CON(2) ((L2Sfin)-(L2Sdeb))/2
RPL
::
CK2NOLASTWD
SWAP TRIMOBJext SWAP VALext
;
ASSEMBLE
L2S      CON(5) (L2S)-(L2Sdeb)+2
***************    L2S
*******************************************************************
*********


**********************************************
***************     XFRC
            CON(2) ((XFRCfin)-(XFRCdeb))/2
XFRCdeb   NIBASC /XFRC/
XFRCfin   CON(2) ((XFRCfin)-(XFRCdeb))/2
RPL
::
CK1NOLASTWD
real_intflag SetUserFlag
' ::	DUP %ABS DUP
*	NULLNAME FCLIext
	::
	DTYPEREAL? NcaseTYPEERR
	RCLEPS %>%%
	DUP %%1/
	ROTDUP	%>%%
	2DUPSWAP %FLOOR ONE{}N SWAP
	BEGIN
		( %%1/eps, %x, %%error, liste, %%x-[x]-... )
		DUP %%FLOOR %%- DUP 7PICK %%<
		ITE FALSE
		::	( %%1/eps, %x, %%error, liste, %%x-[x] )
			%%1/ ROTOVER
			( ..., %x, liste, %%1/x-[x], %%error,  %%1/x-[x] )
			DUP %%* %%1 %%+ %%* UNROT
			( ..., %x, %%error, liste, %%1/x-[x] )
			5PICK 4PICK %%>
			;
	WHILE
	DUPUNROT %%FLOOR %%>%
	>TCOMP SWAP
	REPEAT
	( %%eps, %%1/eps, %x, %%error, liste, %%x-[x] )
	6ROLL  %%<
	( %x, %%error, liste, inferieur a epsilon? [-> rationel] )
	ITE
	::	UNROT2DROP LIFCext
		;
	::	SWAPDROP DUP LIFCext
		( %x, 'p/q' )
		DUP xEVAL ( crunch ? ) 4ROLL %- %ABS RCLEPS %< IT SWAP
		DROP
		;
	SWAPDROP
	;
* end FCLIext
	DTYPELIST?
	ITE ::	INNERCOMP reversym {}N THREE
		BEGIN
			DUP#0<>
		WHILE
			2DUP ONESWAP SUBCOMP OVER 4PICK SWAPDUP 
			#1+SWAP #2* SUBCOMP OVER EQUAL DUP
			IT ::	DROPOVER 4PICK SWAPDUP #2* #1+SWAP 
				THREE #* SUBCOMP OVER EQUAL
				;
			DUP
			IT ::	DROPOVER #1= NOTcase TRUE 3PICK 
				FOUR NTHCOMPDROP OVER INCOMPDROP %=
				;
			NOTcase DROP#1-
			UNROTDUP FOUR #* 3PICK
			LENCOMP #1+
			BEGIN
				2DUP#< DUP
				IT ::	DROP 4PICK 3PICK DUP 6PICK 
					#-+1 SWAP SUBCOMP 6PICK 
					EQUAL
					;
			WHILE
				SWAP3PICK #+SWAP
			REPEAT
			DROPSWAP #-+1 MINUSONE SUBCOMP
			INNERCOMP reversym {}N SWAP
			real_intflag DUP TestUserFlag 4UNROLL
			SetUserFlag
( ID QU )
DUPLENCOMP
::	ONE OVER#=case 
	::	DROP INCOMPDROP %CHS %1 SWAP % -1 
		;
	TWO OVER#=case 
	::	DROP INCOMPDROP 2DUP %* %CHS SWAP %CHS 
		;
	THREE OVER#=case 
	::	DROP INCOMPDROP 2DUP %* DUP %1+ %CHS
		5UNROLL 4PICK DUPROT %* %CHS SWAP %-
		OVER %- 3PICK %+ 5UNROLL DROP %* %1+ UNROT
		;
;
THREE {}N  
NULL{} VXXLext SWAPDROP
DEG2ext CARCOMP
( Fin de QU )
			>TCOMP LIFCext
			SWAP ?SKIP :: real_intflag ClrUserFlag ;
			ZERO
		REPEAT
		DROP DTYPELIST? ?SKIP SWAP DROP
		;
	SWAPDROP SWAP %0< IT RNEGext
	ZEROSWAP NULL{} VAL2ext
	;
' ::	CK&DISPATCH1
	real 2GETEVAL
	TWO :: C%>% 2GETEVAL SWAP 2GETEVAL SWAP C% 0 1 x* x+ ;
	list LISTSECOext
	symb LISTSECOext
	any NOP
	;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL
real_intflag ClrUserFlag
ABND
;
ASSEMBLE
XFRC      CON(5) (XFRC)-(XFRCdeb)+2
***************    XFRC
*******************************************************************

*******************************************************************
***************     STUDMULT
            CON(2) ((STUDMULTfin)-(STUDMULTdeb))/2
STUDMULTdeb   NIBASC /STUDMULT/
STUDMULTfin   CON(2) ((STUDMULTfin)-(STUDMULTdeb))/2
RPL
::
CK2NOLASTWD
RESOROMP RMULText
( { poly2 } { poly1 } oprateur binaire --> { poly3 } )

' :: ( LAM 4 list, o -> )
     DUPTYPESYMB? case 2GETEVAL
     SWAPINCOMP DUP#0= caseDROP
     get1 ROTSWAP 1GETLAM EVAL EVAL SWAP {}N
     ;
' :: ( LAM 3 list A, list B -> listA peut etre un objet non liste )
     OVER TYPESYMB? case 2GETEVAL
     SWAP DUPTYPELIST? ITE INNERCOMP ONE
     DUP#0= caseDROP
     get1
     INNERCOMP
     DUP#0= casedrop {}N
     get1
     ( a1, ..., aa, b1,...,bb, #b, #a )
     SWAP2DUP #MIN SWAP#1+SWAP
     ( a1, ..., aa, b1, ..., bb, #a, #b+1, #min )
     ZERO_DO (DO)
             ( a1, ..., ak, ck+1, ..., cb, b1, ..., bk, #a, #b+1 )
             get1 4ROLL 1GETLAM EVAL EVAL OVER #1+UNROLL
             LOOP
     ( si #a<=#b: c[b-a]+1, ..., cb, b1,..., b[b-a], #a, #b+1 )
     ( si #a>=#b: a1,..., a[a-b], c[a-b]+1,...,ca, #a, #b+1 )
     ( si #a<#b, il faut continuer avec %0 comme oprande )
     #1- 2DUP#< NOTcasedrop ( #b=#a ) {}N
     ( #a < #b : c[b-a]+1,...,ca, b1,...,b[b-a],#a, #b )
     DUPROT #-
     ( c[b-a]+1,...,ca, b1,...,b[b-a], #b, #b-a )
     ZERO_DO (DO)
             ( ck+1,...,ca, b1,...,bk, #b )
             HXS 1 0 ROT 1GETLAM EVAL EVAL OVER #1+UNROLL
             LOOP
     {}N
     ;
' :: ( LAM1 prg principal o, o -> )
     CK&DISPATCH1
     FIVE 3GETLAM
     EIGHTY 4GETLAM
     ZERO 2GETLAM
     ;
4ROLLSWAP ( LAM2: oprateur binaire )
4NULLLAM{} BIND 
1GETLAM EVAL EVAL
ABND
;
ASSEMBLE
STUDMULT      CON(5) (STUDMULT)-(STUDMULTdeb)+2
***************    STUDMULT
*******************************************************************


*******************************************************************
***************     GAUSS
            CON(2) ((GAUSSfin)-(GAUSSdeb))/2
GAUSSdeb   NIBASC /GAUSS/
GAUSSfin   CON(2) ((GAUSSfin)-(GAUSSdeb))/2
RPL
::
CK1
DTYPENDO?
ITE TRUE
    :: xQXA
       ( matr-liste, lvar )
       OVER
       ( matr-liste, lvar, matr-liste )
       FALSE
       ;
SWAPONE
( flag, matr-liste, #1 )
TOLISText '
 :: DUPLENCOMP #1=case :: INCOMPDROP { { HXS 2 10 } } ;
     DUP HXS 1 0 MPMULText OVER EQUALcase :: DUP CARCOMP SWAP ;
     DUPINCOMP reversym DUP#1+ TRUE SWAP
     ( A, l1,...,ln,#n,true, #n+1 )
     ONE_DO (DO)
            ROT INDEX@ NTHCOMPDROP TRIMOBJext HXS 1 0 EQUAL AND
            ( A, l1, ..., lk, #n, boolean )
            ITE TRUE
                :: INDEX@#- NDROP INDEX@ ExitAtLOOP FALSE ;
            LOOP
     ( A, #k, false ou A, #n, true )
     case :: ( aucun carr trouv )
             UNCOERCE xIDN AXLext DUPUNROT
             ( I, A, I )
             { { HXS 1 0 } { HXS 2 1F HXS 1 0 } }
             RADDext
             DUPUNROT TRANext MMULText MMULText
             1GETLAM EVAL
             ( I, D, P )
             ROT
             real_intflag UserITE
             { { SYMBOL HXS 2 1F HXS 2 20 x/ ; SYMBOL HXS 2 10 HXS 2 20 x/ ; }
               { SYMBOL HXS 2 1F HXS 2 20 x/ ; SYMBOL HXS 2 1F HXS 2 20 x/ ; } }
             { { %% -.5 %%.5 } { %% -.5 %% -.5 } }
             RADDext MMULText
             ;
     ( A, #k )
     2DUP NTHCOMPDROP
     ( A, #k, lk )
     DUP3PICK NTHCOMPDROP 4PICK LENCOMP
     ( A, #k, lk, akk, #n )
     ( LAM 4  3    2   1  )
     4NULLLAM{} BIND
     INNERCOMP reversym DROP 4GETLAM ROLLDROP NULL{}
     ( ln, ..., lk+1, lk-1, ..., l1 , {} )
     1GETLAM
     ONE_DO (DO)
            ( ln, ..., lk+1,lk-1,...,lr , {l1,...} )
            SWAPINCOMP reversym 4GETLAM #1+ ROLLDROP
            ( ,{l1,...}, anr,...,ak+1r,ak-1r,...,a1r,#n )
            3GETLAM INDEX@ DUP#1+ 4GETLAM #> IT #1+
            NTHCOMPDROP NULL{} ROT
            ( , anr,...,ak+1r,ak-1r,...,a1r,arr,{},#n )
            ONE_DO (DO)
                   ROT 3PICK 3GETLAM
                   INDEX@ DUP#1+ 4GETLAM #> IT #1+
                   NTHCOMPDROP RMULText
                   2GETLAM RDIVext RSUBext
                   >TCOMP
                   LOOP
            SWAPDROP >TCOMP
            LOOP
     4GETLAM 3GETLAM OVER HXS 2 10 2GETLAM RDIVext
     ABND
     5ROLL 1GETLAM EVAL
     ( #k, lk, #k, 1/akk , D, P)
     4UNROLL
     ( rajoute stk2 en stk3-ime position de stk1 )
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N
     ( fin de routine )
     4UNROLL
     ( D, #k, lk, P )
     TRANext DUPLENCOMP 4PICK HXS 1 0 ROT NDUPN {}N ROT
     ( D, #k, lk, #k, {%0}, P )
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N TRANext
     INNERCOMP get1 SWAP#1+ get1
     OVERSWAP #- #2+ ROTSWAP UNROLL {}N
     ;
DUP1LAMBIND EVAL ABND
( [matr-liste, lvar], flag_list_input, lvar, D, P )
{ ONE TWO } FROMLISText
ROT ?SEMI
( matr-liste, lvar, D, P )
2DUP 5PICK
( matr-liste, lvar, D, P, D, P, lvar )
SWAPINCOMP get1 NULL{} ROT
ZERO_DO (DO)
        OVER 4ROLL
        ( XYext )
        INNERCOMP #1+ROLL INNERCOMP
        DUP#1= casedrop x*
        get1
        ( y1, ..., yn-1, x1, ..., xn, #n, yn )
        ROT x*
        ( y1, ..., yn-1, x1, ..., xn-1, #n, xn*yn )
        SWAPDUP
        ONE_DO (DO)
               ( y1, ..., yn-k, x1, ..., xn-k, x.y, #n-k+1 )
               get1
               ( y1, ..., yn-k-1, x1, ..., xn-k, x.y, #n-k+1, yn-k )
               ROTSWAP
               ( y1, ..., yn-k-1, x1, ..., xn-k, #n-k+1, x.y, yn-k )
               4ROLL
               ( y1, ..., yn-k-1, x1, ..., #n-k+1, x.y, yn-k, xn-k )
               x* x+ SWAP#1-
               LOOP
               ( X.Y, # )
        DROP
        ( end of XYext )
        >HCOMP
        LOOP
SWAPDROP
( matr-liste, lvar, D, P, D, Dxyz )
INNERCOMP #1+ROLL INNERCOMP DUP #3+ %0 ROT
ZERO_DO (DO)
        ROT 3PICK PICK %2 x^ x* x+
        LOOP
OVER #1- UNROLL #3- NDROP
( matr-liste, lvar, D, P, symb )
5UNROLL 2SWAP 5ROLL
( D, P, matr-liste, lvar, symb )
;
ASSEMBLE
GAUSS      CON(5) (GAUSS)-(GAUSSdeb)+2
***************    GAUSS
*******************************************************************


*******************************************************************
***************     TEVAL
            CON(2) ((TEVALfin)-(TEVALdeb))/2
TEVALdeb   NIBASC /TEVAL/
TEVALfin   CON(2) ((TEVALfin)-(TEVALdeb))/2
RPL
::
CK1
GARBAGE CLKTICKS 1LAMBIND EVAL CLKTICKS 1GETABND
bit- HXS>% % 8192 %/ % 0.0067 %- %4 RNDXY "s" >TAG
;
ASSEMBLE
TEVAL      CON(5) (TEVAL)-(TEVALdeb)+2
***************    TEVAL
*******************************************************************
*********


*******************************************************************
***************     LATEX
            CON(2) ((LATEXfin)-(LATEXdeb))/2
LATEXdeb   NIBASC /LATEX/
LATEXfin   CON(2) ((LATEXfin)-(LATEXdeb))/2
RPL
::
' :: ( LAM2 #; STR  STR )
 SWAP DUP#0=csDROP
 DUP#1= casedrop 
  :: "\\left(" SWAP&$ "\\right)" &$ ;
 TWO #=casedrop 
  :: CHR_] >T$ CHR_[ >H$ ;
 THREE #=casedrop 
  :: CHR_} >T$ CHR_{ >H$ ;
 SETSIZEERR
 ;
' :: CK&DISPATCH1
real DO>STR
TWO ( cmp ) DO>STR
ELEVEN ( hxs ) :: HXS>% DO>STR ;
THREE ( str ) NOP
SIX ID>$
symb :: ' xOBJ\-> EvalNoCK
  SWAP COERCE
  ONE #=casedrop
   :: ( o1; oper )
     SWAP 1GETLAM EVAL
     { xNEG { "-" TRUE ONE }
       xSQ { "^2" FALSE ONE }
       xINV { "\\frac{1}" TRUE THREE }
     }
     ROTSWAP EQLookup
     ITE INCOMPDROP 
         :: DO>STR "\\" SWAP&$ TRUE ONE ;
     4ROLL 2GETEVAL 
     SWAP ITE &$ SWAP&$
     ;
  TWO #=casedrop
   :: ( O1; O2; OPER )
     ROT 1GETLAM EVAL
     ROT 1GETLAM EVAL
     { x+ { "+" TRUE ZERO ZERO }
       x- { "-" TRUE ONE ZERO }
       x* { "\\times " TRUE ONE ONE }
       x/ { "\\frac" FALSE THREE THREE }
       x^ { "^" TRUE THREE ZERO }
       xXROOT { "\\sqrt" FALSE TWO THREE }
     }
     4ROLLSWAP EQLookup NcaseSIZEERR
     INCOMPDROP
     6ROLL 2GETEVAL
     5UNROLL 4ROLL 2GETEVAL
     SWAP ?SKIP ROTSWAP &$ &$
   ;
  DROP
  ' x\.S EQUALcasedro
  :: 1GETLAM EVAL CHR_d >H$ 
     $ "\\int_{" 5ROLL 
     1GETLAM EVAL &$ $ "}^{" &$
     4ROLL 1GETLAM EVAL &$
     CHR_} >T$ ROT 1GETLAM EVAL
     &$ "\\ " &$ SWAP&$
     ;
  xSHALT 
  ;
 ;
' NULLLAM DUPTWO DOBIND
1GETLAM EVAL ABND
;
ASSEMBLE
LATEX      CON(5) (LATEX)-(LATEXdeb)+2
***************    LATEX
*******************************************************************

*******************************************************************
***************     TNBA
dernier		CON(2) ((TNBAfin)-(TNBAdeb))/2
TNBAdeb   NIBASC /TNBA/
TNBAfin   CON(2) ((TNBAfin)-(TNBAdeb))/2
RPL
::
CK1NOLASTWD
* argument checking
DUPTYPELIST? NcaseTYPEERR
DUPLENCOMP #3= NcaseSIZEERR
* tangent
DUP "Pos" >TAG SWAPDUP
( "pos", v, v )
LIDNText CARCOMP
( "pos", v, 1st var )
DUP1LAMBIND DERIVext SIMP1ext
( "pos", v' )

LABEL norm!
::
( v -> v, norm[v] )
DUP INCOMPDROP DUP x*ext
SWAPDUP x*ext x+ext
SWAPDUP x*ext x+ext SIMP1ext
;

( "pos", v', norm[v']^2 )
2DUP XSQRext SIMP1ext DUP 5UNROLL ' NDXFext LOP1ext "T" >TAG
( "pos", norm[v'], v', norm[v']^2, tangent )
4UNROLL 2DUP
( "pos", tangent, norm[v'], v', norm[v']^2, v', norm[v']^2 )
2DUPSWAP 1GETLAM DERIVext SIMP1ext
( "pos", tangent, norm[v'], v', norm[v']^2, v', norm[v']^2, norm[v']^2, v''  )
DUP 6UNROLL SWAP %2 x*ext VPMULText 
( "pos", tangent, norm[v'], v', v'', norm[v']^2, v', norm[v']^2, v''*2*norm[v']^2 )
UNROT 1GETLAM DERIVext SIMP1ext VPMULText RSUBext SIMP1ext
( "pos", tangent, norm[v'], v', v'',norm[v']^2, v''*2*norm[v']^2-v'*norm[v']^2' )
2DUPSWAP %2 x*ext ' NDXFext LOP1ext SIMP1ext
6PICK ' NDXFext LOP1ext "N" >TAG 6UNROLL
( "pos", tangent, normal, norm[v'], v', v'', norm[v']^2, v''*... )
4PICK xcross SIMP1ext
CODE
	GOTO	tonorm
ENDCODE
' xINV EvalNoCK XSQRext SIMP1ext VPMULText SIMP1ext "Bi" >TAG 5UNROLL
( "pos", tangent, normal, bi, norm[v'], v', v'', norm[v']^2 )
SWAP
CODE
tonorm		A=PC
		LC(5)	(norm!)-(*)
		A=A+C	A
		PC=(A)
ENDCODE
( "pos", tangent, normal, norm[v'], v', norm[v']^2, v'', norm[v'']^2 )
4ROLLROT XYext SIMP1ext 
( "pos", tangent, normal, norm[v'], norm[v']^2, norm[v'']^2, v'.v'' )
DUP 5ROLL NDXFext "a_T" >TAG 4UNROLL
( "pos", tangent, normal, acc_tan, norm[v']^2, norm[v'']^2, v'.v'' )
DUP x*ext ROT NDXFext x-ext XSQRext SIMP1ext "a_N" >TAG
( "pos", tangent, normal, acc_tan, acc_norm )
ABND
;
*ASSEMBLE
*TNBA      CON(5) (TNBA)-(TNBAdeb)+2
***************    TNBA
*******************************************************************


